SystemOrganization addCategory: #'DeprecatedPreferences-Browser'!
SystemOrganization addCategory: #'DeprecatedPreferences-Core'!
SystemOrganization addCategory: #'DeprecatedPreferences-Users'!

SystemWindow subclass: #PreferenceBrowserMorph
	instanceVariableNames: 'mainPanel defaultButton saveButton loadButton saveToDiskButton loadFromDiskButton themeButton helpButton preferenceList lastKeystrokeTime lastKeystrokes highlightedPreferenceButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PreferenceBrowserMorph classSide methodsFor: 'instance creation' stamp: 'hpt 9/18/2004 15:31'!
withModel: aPreferenceBrowser
	^self new initializeWithModel: aPreferenceBrowser;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/20/2004 23:31'!
adjustPreferenceListItemsWidth
	| panel |
	self preferenceList scroller submorphs 
		ifEmpty: [^self].
	panel := self preferenceListInnerPanel. 
	panel width: self preferenceList width - (self preferenceList scrollBarThickness*2).
	panel submorphsDo: [:ea | ea hResizing: #rigid; width: panel width].
	self preferenceList setScrollDeltas.! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 1/27/2009 16:22'!
basicButton
	"Answer an initialised button for use in the button row."
	
	^(UITheme builder
		newButtonFor: self model
		action: nil
		label: ''
		help: nil)
		vResizing: #spaceFill;
		hResizing: #shrinkWrap! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:12'!
basicKeyPressed: anEvent
	| aChar oldSelection nextSelection max milliSeconds nextSelectionList nextSelectionPref |
	aChar := anEvent keyCharacter.
	nextSelection := oldSelection := self selectedPreferenceIndex.
	max := self selectedCategoryPreferences size.
	milliSeconds := Time millisecondClockValue.
	milliSeconds - lastKeystrokeTime > 300 ifTrue: ["just use the one current character for selecting"
		lastKeystrokes := ''].
	lastKeystrokes := lastKeystrokes , aChar asLowercase asString.
	lastKeystrokeTime := milliSeconds.
	nextSelectionList := OrderedCollection newFrom: (self selectedCategoryPreferences copyFrom: oldSelection + 1 to: max).
	nextSelectionList addAll: (self selectedCategoryPreferences copyFrom: 1 to: oldSelection).
	"Get rid of blanks and style used in some lists"
	nextSelectionPref := nextSelectionList detect: [:a | a name withBlanksTrimmed asLowercase beginsWith: lastKeystrokes]
				ifNone: [^ self preferenceList flash"match not found"].
	nextSelection := self selectedCategoryPreferences findFirst: [:a | a  = nextSelectionPref].
	"No change if model is locked"
	oldSelection == nextSelection ifTrue: [^ self preferenceList flash].
	^ self selectedPreferenceIndex: nextSelection! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 8/28/2005 00:04'!
buttonRowLayoutFrame 
	^LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@ (TextStyle defaultFont height * 2.5))! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:55'!
defaultButton
	^defaultButton ifNil: 
		[defaultButton := self basicButton 
						label: 'default' translated; 
						actionSelector: #defaultSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their standard ',
							'default values.' translated]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
downKeyPressed: anEvent
	self selectedPreferenceIndex:
		(self selectedPreferenceIndex + 1 
				min: self selectedCategoryPreferences size)! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:17'!
endKeyPressed: anEvent
	self selectedPreferenceIndex: self selectedCategoryPreferences size.
! !

!PreferenceBrowserMorph methodsFor: 'geometry' stamp: 'hpt 9/18/2004 21:05'!
extent: aPoint
	super extent: aPoint.
	self fullBounds.
	self adjustPreferenceListItemsWidth.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
helpButton
	^helpButton ifNil: 
		[helpButton := self basicButton 
						label: 'help' translated; 
						setBalloonText: 
							'Click here to get some hints on use of this Preferences ',
							'Panel' translated;
						actionSelector: #helpSelected]! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
homeKeyPressed: anEvent
	self selectedPreferenceIndex: 1.
! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 2/2/2009 13:33'!
initializeWithModel: aPreferenceBrowser
	"Initialize the receiver based on the given model."
	
	|buttonRow|
	lastKeystrokeTime := 0.
	lastKeystrokes := ''.
	self model: aPreferenceBrowser.
	buttonRow := self newButtonRow.
	self 
		clipSubmorphs: true;
		setLabel: self model windowTitle;
		name: 'PreferenceBrowser';
		addMorph: self rootPanel
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@(buttonRow minExtent y) corner: 0@0));
		addMorph: buttonRow
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@ buttonRow minExtent y))! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:19'!
keyPressed: anEvent
	self selectedCategory 
		ifNil: [^self].
	anEvent keyValue = 30
		ifTrue: [^self upKeyPressed: anEvent].
	anEvent keyValue = 31
		ifTrue: [^self downKeyPressed: anEvent].
	anEvent keyValue = 1 
		ifTrue: [^self homeKeyPressed: anEvent].
	anEvent keyValue = 4
		ifTrue: [^self endKeyPressed: anEvent].
	anEvent keyValue = 11
		ifTrue: [^self pageUpKeyPressed: anEvent].
	anEvent keyValue = 12
		ifTrue: [^self pageDownKeyPressed: anEvent].
	self basicKeyPressed: anEvent.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadButton
	^loadButton ifNil: 
		[loadButton := self basicButton 
						label: 'load' translated; 
						actionSelector: #loadSelected;						
						setBalloonText: 
							'Click here to reset all the preferences to their values ',
							'in your Personal Preferences.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
loadFromDiskButton
	^loadFromDiskButton ifNil: 
		[loadFromDiskButton := self basicButton 
						label: 'load from disk' translated; 
						actionSelector: #loadFromDiskSelected;						
						setBalloonText: 
							'Click here to load all the preferences from ',
							'their saved values on disk.' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - main panel' stamp: 'hpt 9/19/2004 03:01'!
mainPanel
	^mainPanel ifNil: 
		[mainPanel := Morph new
			color: Color transparent;
			hResizing: #spaceFill;
			vResizing: #spaceFill;
			cellInset: 5;
			layoutPolicy: TableLayout new;
			listCentering: #topLeft;
			listDirection: #leftToRight;
			cellPositioning: #topLeft;
			clipSubmorphs: true;
			on: #mouseEnter send: #paneTransition: to: self;
			addMorphBack: self newCategoryListPanel;
			addMorphBack: self newPreferenceListPanel;
			yourself].! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/26/2004 23:01'!
mouseDownOn: aPreferenceView event: anEvent
	anEvent hand newKeyboardFocus: self preferenceList scroller.
	anEvent yellowButtonPressed
		ifTrue: [aPreferenceView offerPreferenceNameMenu: self model]! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'MarcusDenker 11/29/2009 09:36'!
newButtonRow
	"Answer a new button row."
	
	^(UITheme builder newToolDockingBar addMorph: (
		(UITheme builder newRow: {
			self defaultButton.
			self newSeparator.
			self saveButton.
			self loadButton.
			self newSeparator.
			self saveToDiskButton.
			self loadFromDiskButton.
			self newTransparentFiller.
			self newSeparator.
			self helpButton})
			vResizing: #spaceFill))
		layoutInset: 1! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/18/2004 16:07'!
newCategoryList 
	^(PluggableListMorph
		on: self model
		list: #categoryList
		selected: #selectedCategoryIndex
		changeSelected: #selectedCategoryIndex:)
			color: Color white;
			borderInset;
			vResizing: #spaceFill;
			hResizing: #rigid;
			width: 150;
			yourself.! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 6/2/2009 10:29'!
newCategoryListPanel
	"Answer a groupbox for the categories list."
	
	^(UITheme builder
		newGroupbox: 'Categories' translated
		for: (self newCategoryList 
			cornerStyle: StandardWindow basicNew preferredCornerStyle))
		hResizing: #shrinkWrap;
		cornerStyle: StandardWindow basicNew preferredCornerStyle! !

!PreferenceBrowserMorph methodsFor: 'submorphs - category list' stamp: 'hpt 9/19/2004 02:29'!
newCategoryListPanelLabel 
	^StringMorph contents: 'Categories' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceButtonFor: aPreference 
	| button |
	button := PBPreferenceButtonMorph preference: aPreference model: self model.
	button 
		on: #mouseDown
		send: #value:
		to: 
			[:anEvent | 
			self
				selectedPreference: aPreference;
				mouseDownOn: button preferenceView event: anEvent].
	^button! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 17:20'!
newPreferenceListInnerPanel
	| panel maxWidth totalHeight |
	panel := (Morph new)
				color: Color transparent;
				layoutPolicy: TableLayout new;
				listDirection: #topToBottom;
				cellPositioning: #topLeft;
				yourself.
	self selectedCategoryPreferences 
		do: [:aPref | panel addMorphBack: (self newPreferenceButtonFor: aPref)].
	panel submorphs size = 0 ifTrue: [^panel].
	maxWidth := (panel submorphs detectMax: [:m | m width]) width.
	panel width: maxWidth.
	totalHeight := (panel submorphs collect: [:ea | ea height]) inject: 0
				into: [:h :tot | h + tot].
	panel height: totalHeight.
	panel fullBounds.
	^panel! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 6/2/2009 10:25'!
newPreferenceListPanel
	"Answer a groupbox for the preferences list."
	
	^(UITheme builder
		newGroupbox: 'Preferences' translated
		for: self preferenceList)
		cornerStyle: StandardWindow basicNew preferredCornerStyle! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 02:29'!
newPreferenceListPanelLabel 
	^StringMorph contents: 'Preferences' translated.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - search panel' stamp: 'hpt 9/19/2004 02:55'!
newSearchButton
	^self basicButton
			label: 'search' translated; 
			actionSelector: #searchSelected;
			setBalloonText: 
				'Type what you want to search for here, then hit ',
				'the "Search" button, or else hit RETURN or ENTER' translated.! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 1/27/2009 16:54'!
newSearchPanel
	"Answer the panel for searching of preferences."
	
	^UITheme builder newRow: {
		UITheme builder newLabel: 'Search preferences for:' translated.
		self newSearchTextField}! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 1/27/2009 16:49'!
newSearchTextField
	"Answer a new text entry for searching of preferences."
	
	^UITheme builder
		newAutoAcceptTextEntryFor: self model
		getText: #searchPattern
		setText: #searchPattern:
		getEnabled: nil
		help: 'Filters the preferences according to a prefix' translated! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 1/27/2009 16:29'!
newSeparator
	"Answer a new separator for the button row."
	
	^UITheme builder newToolbarHandle! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:49'!
newTransparentFiller
	^Morph new
		color: Color transparent;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:24'!
pageDownKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex + self preferencesShowing size min: self selectedCategoryPreferences size).
! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:30'!
pageUpKeyPressed: anEvent
	self selectedPreferenceIndex: (self selectedPreferenceIndex - self preferencesShowing size max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'AlainPlantec 12/10/2009 14:31'!
preferenceList
	"Changed to take MorphicModel>>keyboardFocusOnMouseDown preference into account."
	
	^preferenceList ifNil:
		[preferenceList := ScrollPane new
			color: Color white;
			borderStyle: (BorderStyle inset width: 1);
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			cornerStyle: StandardWindow basicNew preferredCornerStyle.
		preferenceList keyboardFocusOnMouseDown
			ifFalse: [preferenceList scroller
						on: #mouseEnter send: #value: 
						to: [:event | preferenceList scroller takeKeyboardFocus]].
		preferenceList scroller
			on: #keyStroke send: #keyPressed: to: self.
		preferenceList]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/18/2004 21:19'!
preferenceListInnerPanel
	^self preferenceList scroller submorphs first! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 9/19/2004 00:29'!
preferencesShowing
	| prefs |
	prefs := self preferenceListInnerPanel submorphs
					copyFrom: (self selectedPreferenceIndex max: 1)
					to: self selectedCategoryPreferences size.
	^prefs reject: [:ea | (ea top - prefs first top) > self preferenceList scroller height].! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 1/27/2009 16:33'!
rootPanel
	"Answer a new root panel for the main contents of the browser."
	
	^UITheme builder newPanel
		addMorphBack: self newSearchPanel;
		addMorphBack: self mainPanel;
		yourself! !

!PreferenceBrowserMorph methodsFor: 'submorphs - root panel' stamp: 'stephaneducasse 2/4/2006 20:39'!
rootPanelLayoutFrame 
	| frame |
	frame := self buttonRowLayoutFrame.
	^LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@(frame bottomOffset) corner: 0@0)! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveButton
	^saveButton ifNil: 
		[saveButton := self basicButton 
						label: 'save' translated; 
						actionSelector: #saveSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings as your personal defaults; you can get them all ',
							'reinstalled with a single gesture by clicking the "Restore ',
							'my Personal Preferences".' translated]! !

!PreferenceBrowserMorph methodsFor: 'submorphs - buttons' stamp: 'hpt 9/18/2004 16:56'!
saveToDiskButton
	^saveToDiskButton ifNil: 
		[saveToDiskButton := self basicButton 
						label: 'save to disk' translated; 
						actionSelector: #saveToDiskSelected;						
						setBalloonText: 
							'Click here to save the current constellation of Preferences ',
							'settings to a file; you can get them all reinstalled with a ', 
							'single gesture by clicking "Restore Settings From Disk".'
								 translated]! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategory
	^self model selectedCategory! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex
	^self model selectedCategoryIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryIndex: anIndex
	^self model selectedCategoryIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedCategoryPreferences
	^self model selectedCategoryPreferences! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:05'!
selectedPreference
	^self model selectedPreference! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:06'!
selectedPreference: aPreference
	^self model selectedPreference: aPreference! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:50'!
selectedPreferenceButton
	^(self preferenceListInnerPanel submorphs at: self selectedPreferenceIndex)! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex
	^self model selectedPreferenceIndex! !

!PreferenceBrowserMorph methodsFor: 'model access' stamp: 'hpt 9/19/2004 00:10'!
selectedPreferenceIndex: anIndex
	^self model selectedPreferenceIndex: anIndex! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'hpt 12/8/2004 15:54'!
turnOffSelectedPreference
	highlightedPreferenceButton 
		ifNil: [^self].
	highlightedPreferenceButton highlightOff.
	highlightedPreferenceButton := nil.! !

!PreferenceBrowserMorph methodsFor: 'submorphs - preference list' stamp: 'marcus.denker 11/10/2008 10:04'!
turnOnSelectedPreference
	highlightedPreferenceButton 
		ifNotNil: [:m | m highlightOff].
	highlightedPreferenceButton := self selectedPreferenceButton
		highlightOn;
		yourself.
	self preferenceList scrollToShow: highlightedPreferenceButton bounds.! !

!PreferenceBrowserMorph methodsFor: 'event handling' stamp: 'hpt 9/19/2004 00:16'!
upKeyPressed: anEvent
	self selectedPreferenceIndex: 
			(self selectedPreferenceIndex - 1 max: 1).
! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/18/2004 21:16'!
update: aSymbol
	super update: aSymbol.
	aSymbol == #selectedPreference
		ifTrue: [self updateSelectedPreference].
	aSymbol == #selectedCategoryIndex
		ifTrue: [self updateSelectedCategoryPreferences].! !

!PreferenceBrowserMorph methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:34'!
updateSelectedCategoryPreferences
	Cursor wait showWhile: 
		[self preferenceList 
				hScrollBarValue: 0;
				vScrollBarValue: 0.
		self preferenceList scroller removeAllMorphs.
		self preferenceList scroller addMorphBack: self newPreferenceListInnerPanel.
		self preferenceList adoptPaneColor.
		self adjustPreferenceListItemsWidth]! !

!PreferenceBrowserMorph methodsFor: 'updating' stamp: 'hpt 9/19/2004 00:08'!
updateSelectedPreference
	| index |
	self selectedCategory ifNotNil: [self turnOffSelectedPreference].
	index := self selectedPreferenceIndex.
	index = 0
		ifTrue: [^self].
	self turnOnSelectedPreference.! !

RectangleMorph subclass: #UpdatingRectangleMorph
	instanceVariableNames: 'target lastValue getSelector putSelector contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!UpdatingRectangleMorph commentStamp: '<historical>' prior: 0!
Intended for use as a color swatch coupled to a color obtained from the target, but made just slightly more general than that.!

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 9/4/97 21:43'!
contents
	^ contents! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 9/4/97 21:43'!
contents: c
	contents := c! !

!UpdatingRectangleMorph methodsFor: 'initialization' stamp: 'dgd 2/14/2003 22:35'!
defaultBorderColor
	"answer the default border color/fill style for the receiver"
	^ Color lightGray lighter! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 1/6/2005 16:31'!
getSelector
	"Answer the getSelector"

	^ getSelector! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
getSelector: aSymbol

	getSelector := aSymbol.
! !

!UpdatingRectangleMorph methodsFor: 'event handling' stamp: 'dgd 2/22/2003 18:45'!
handlesMouseDown: evt 
	^putSelector notNil! !

!UpdatingRectangleMorph methodsFor: 'event handling' stamp: 'ar 10/5/2000 18:54'!
mouseUp: evt

	self changeColorTarget: self selector: #setTargetColor: originalColor: color hand: evt hand.! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 10/30/97 00:55'!
putSelector
	^ putSelector! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 10/30/97 00:55'!
putSelector: aSymbol
	putSelector := aSymbol! !

!UpdatingRectangleMorph methodsFor: 'target access' stamp: 'dgd 2/22/2003 14:40'!
readFromTarget
	"Read the color value from my target"

	| v |
	(target isNil or: [getSelector isNil]) ifTrue: [^contents].
	target isMorph ifTrue: [target isInWorld ifFalse: [^contents]].
	v := self valueProvider perform: getSelector.
	lastValue := v.
	^v! !

!UpdatingRectangleMorph methodsFor: 'setting' stamp: 'sw 3/23/2001 23:26'!
setTargetColor: aColor
	"Set my target's color as indicated"

	putSelector ifNotNil:
		[self color: aColor.
		contents := aColor.
		self valueProvider perform: self putSelector withArguments: (Array with: aColor)]
! !

!UpdatingRectangleMorph methodsFor: 'stepping and presenter' stamp: 'sw 7/15/1999 07:27'!
step
	| s |
	super step.
	s := self readFromTarget.
	s = contents ifFalse:
		[self contents: s.
		self color: s]
! !

!UpdatingRectangleMorph methodsFor: 'testing' stamp: ''!
stepTime

	^ 50! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
target

	^ target
! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: ''!
target: anObject

	target := anObject.
! !

!UpdatingRectangleMorph methodsFor: 'accessing' stamp: 'sw 11/15/2001 16:22'!
userEditsAllowed
	"Answer whether it is suitable for a user to change the value represented by this readout"

	^ putSelector notNil! !

!UpdatingRectangleMorph methodsFor: 'setting' stamp: 'HenrikSperreJohansen 9/10/2009 15:07'!
valueProvider
	"Answer the object to which my get/set messages should be sent.  This is inefficient and contorted in order to support grandfathered content for an earlier design"

	^ target ! !

!UpdatingRectangleMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 17:17'!
veryDeepFixupWith: deepCopier
	"If target and arguments fields were weakly copied, fix them here.  If they were in the tree being copied, fix them up, otherwise point to the originals!!!!"

super veryDeepFixupWith: deepCopier.
target := deepCopier references at: target ifAbsent: [target].! !

!UpdatingRectangleMorph methodsFor: 'copying' stamp: 'tk 1/7/1999 17:17'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"target := target.		Weakly copied"
lastValue := lastValue veryDeepCopyWith: deepCopier.
"getSelector := getSelector.		a Symbol"
"putSelector := putSelector.		a Symbol"
contents := contents veryDeepCopyWith: deepCopier.! !

Model subclass: #PreferenceBrowser
	instanceVariableNames: 'selectedCategoryIndex selectedPreference searchPattern searchResults lastExecutedSearch preferences title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'AlainPlantec 12/16/2009 21:27'!
initialize
	self
		registerInOpenMenu! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'AlainPlantec 2/18/2010 11:20'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #PreferenceBrowser)
		label: 'Preference browser';
		action: [self open];
		parent: #System;
		icon: self taskbarIcon
! !

!PreferenceBrowser classSide methodsFor: 'instance creation' stamp: 'stephaneducasse 2/4/2006 20:39'!
open
	| browser |
	browser := self new.
	(PreferenceBrowserMorph withModel: browser)
		openInWorld.
	^browser.	! !

!PreferenceBrowser classSide methodsFor: 'window color' stamp: 'AlainPlantec 12/16/2009 22:09'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color fromRgbTriplet: #(0.645 1.0 1.0)
! !

!PreferenceBrowser classSide methodsFor: 'initialization' stamp: 'AlainPlantec 10/17/2009 16:44'!
unload
	self 
		unregisterFromOpenMenu! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
allCategoryLabel
	^'-- all --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 17:59'!
allCategorySelected
	^self selectedCategory = self allCategoryLabel! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
allPreferences
	^ preferences allPreferenceObjects  asSortedCollection:
			[:pref1 :pref2 | 
			pref1 viewRegistry viewOrder  <pref2 viewRegistry viewOrder  or:
					[pref1 viewRegistry viewOrder  =pref2 viewRegistry viewOrder 
						 &(pref1 name  <pref2 name)]]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
categoryList
	^OrderedCollection new
		add:  self allCategoryLabel;
		addAll: preferences categoryNames asSortedCollection;
		add: self searchResultsCategoryLabel;
		yourself.
	
	! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 9/19/2004 12:01'!
defaultSelected
	Preferences chooseInitialSettings! !

!PreferenceBrowser methodsFor: 'find' stamp: 'rr 10/1/2005 15:05'!
findCategoryFromPreference: prefSymbol
	"Find all categories in which the preference occurs"

	| aMenu| 
	aMenu := MenuMorph new defaultTarget: self.
	(preferences categoriesContainingPreference: prefSymbol) do:
		[:aCategory | aMenu add: aCategory target: self selector: #selectedCategory: argument: aCategory].
	aMenu popUpInWorld! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 13:18'!
helpSelected 
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: self helpText;
		openLabel: self windowTitle.! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'adrian_lienhard 7/18/2009 15:59'!
helpText
	^(String streamContents: [:str |
		str nextPutAll:
'Many aspects of the system are goberned by the settings of various ''Preferences''.

Click on any of the categories shown at the left list to see all the preferences in that category. Or type into the search box at the bottom of the window, then hit Search, and all Preferences matching whatever you typed in will appear in the ''search results'' category. A preference is considered to match your search if either its name matches the text *or* if anything in the preference''s help text does.

To find out more about any particular Preference just select it and its help text will appear.

Some preferences can be ''local'' instead of global. When a preference is set as global its value will apply to whatever project you are in. A local preference will only be valid in the project that you set it in.

The ''Save'' button allow you to quickly save your current settings so it can later be restored with the ''Load'' button.

To carry your settings to another image you might want to use the ''Save to disk'' and ''Load from disk'' buttons. The save to disk option will store all your settings in a ''my.prefs'' file in your Pharo''s current directory.

Lastly, you can use the "theme..." button to set multiple preferences all at once; click on the "theme..." button and try the themes already provided with your Pharo image.']) translated! !

!PreferenceBrowser methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:45'!
initialExtent
	"Made a bit wider to line up prefs nicely."
	
	^580@440! !

!PreferenceBrowser methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 10:15'!
initialize
	super initialize.
	preferences := Preferences.
	title := 'Preference Browser'.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:35'!
lastExecutedSearch
	^lastExecutedSearch! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
lastExecutedSearch: aTextOrString
	^lastExecutedSearch:= aTextOrString! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
loadFromDiskSelected 
	preferences restorePreferencesFromDisk! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
loadSelected
	preferences restorePersonalPreferences ! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
nonSpecialCategorySelected
	^self allCategorySelected not & self searchResultsCategorySelected not! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/11/2005 17:14'!
preferences
	^ preferences! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:05'!
preferencesInCategory: aCategory
	^(preferences preferenceObjectsInCategory: aCategory)! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
saveSelected
	preferences savePersonalPreferences ! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'rr 10/1/2005 15:05'!
saveToDiskSelected 
	preferences storePreferencesToDisk! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 7/8/2006 17:50'!
searchFieldLegend
	^''.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 8/27/2005 23:39'!
searchPattern
	^searchPattern ifNil: [searchPattern := self searchFieldLegend]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchPattern: aStringOrText
	aStringOrText 
		ifEmpty: [searchPattern := self searchFieldLegend]
		ifNotEmpty: [searchPattern := aStringOrText asString].
	self changed: #searchPattern.
	^true! !

!PreferenceBrowser methodsFor: 'preferences search' stamp: 'hpt 8/27/2005 23:36'!
searchPreferencesFor: pattern
	| result |
	result := pattern asString asLowercase withBlanksTrimmed.
	result ifEmpty: [^self].
	searchResults := self allPreferences select: [:aPreference |
		(aPreference name includesSubstring: result caseSensitive: false) or:
				[aPreference helpString includesSubstring: result caseSensitive: false]].		
	self selectSearchResultsCategory.
	self lastExecutedSearch: pattern.
! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
searchResults
	^searchResults ifNil: [searchResults := #()]! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'hpt 9/19/2004 02:30'!
searchResultsCategoryLabel
	^'-- search results --' translated! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 18:01'!
searchResultsCategorySelected
	^self selectedCategory = self searchResultsCategoryLabel! !

!PreferenceBrowser methodsFor: 'buttons callbacks' stamp: 'hpt 9/19/2004 03:21'!
searchSelected
	self searchPreferencesFor: self searchPattern.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
selectFirstPreferenceOrNil
	| prefs |
	self selectedCategory
		ifNil: [^self selectedPreference: nil].
	prefs := self preferencesInCategory: self selectedCategory.
	prefs isEmpty
		ifTrue: [^self selectedPreference: nil].
	self selectedPreference: prefs first.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:23'!
selectSearchResultsCategory
	self selectedCategoryIndex: (self categoryList indexOf: self searchResultsCategoryLabel)! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:01'!
selectedCategory
	^self categoryList at: selectedCategoryIndex ifAbsent: []! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/25/2004 17:09'!
selectedCategory: aCategorySymbol
	self selectedCategoryIndex: (self categoryList indexOf: aCategorySymbol ifAbsent: [0]).! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:49'!
selectedCategoryIndex
	^selectedCategoryIndex ifNil: [selectedCategoryIndex := 0].! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:45'!
selectedCategoryIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: nil.
	selectedCategoryIndex := anIndex.
	self changed: #selectedCategoryIndex.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 03:27'!
selectedCategoryPreferences
	self allCategorySelected
		ifTrue: [^self allPreferences].
	self searchResultsCategorySelected 
		ifTrue: [^self searchResults].
	^self preferencesInCategory: self selectedCategory.
	! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 20:53'!
selectedPreference
	^selectedPreference! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/19/2004 00:39'!
selectedPreference: aPreference
	selectedPreference := aPreference.
	self changed: #selectedPreference.
	self changed: #selectedPreferenceIndex.
	self changed: #selectedPreferenceHelpText.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:22'!
selectedPreferenceHelpText
	self selectedPreference
		ifNil: [^''].
	^self selectedPreference helpString withBlanksTrimmed.! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 21:17'!
selectedPreferenceIndex
	^self selectedCategoryPreferences indexOf: self selectedPreference ifAbsent: [0]! !

!PreferenceBrowser methodsFor: 'accessing' stamp: 'hpt 9/18/2004 23:41'!
selectedPreferenceIndex: anIndex
	anIndex = 0
		ifTrue: [^self].
	self selectedPreference: (self selectedCategoryPreferences at: anIndex).! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:35'!
stepAt: millisecondClockValue in: aWindow
	super stepAt: millisecondClockValue in: aWindow.
	self searchPattern ~= self lastExecutedSearch
		ifTrue: [self searchPreferencesFor: self searchPattern].! !

!PreferenceBrowser methodsFor: 'stepping' stamp: 'hpt 8/27/2005 23:41'!
wantsStepsIn: aWindow
	^true.! !

!PreferenceBrowser methodsFor: 'user interface' stamp: 'rr 1/8/2006 12:35'!
windowTitle
	^ title translated! !

Morph subclass: #PBPreferenceButtonMorph
	instanceVariableNames: 'moreButton model preference preferenceMorphicView preferenceView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBPreferenceButtonMorph classSide methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:20'!
preference: aPreference
	^self preference: aPreference model: nil! !

!PBPreferenceButtonMorph classSide methodsFor: 'instance creation' stamp: 'hpt 12/8/2004 15:19'!
preference: aPreference model: aModel
	^self new
		initializeWithPreference: aPreference model: aModel;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:15'!
actionButtons
	^self preferenceView actions collect: [:aTuple |
		self basicButton
				label: aTuple first;
				target: aTuple second;
				actionSelector: aTuple third;
				arguments: aTuple fourth;
				setBalloonText: aTuple fifth ]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 8/24/2005 20:33'!
addExtraControls
	| m |
	m := self horizontalPanel
		cellInset: 3;
		addAllMorphs: self actionButtons;
		addMorphBack: self horizontalFiller;
		addMorphBack: self moreButton;
		yourself.
	self 
		addMorphBack: (self blankSpaceOf: 2@2);
		addMorphBack: self preferenceHelpTextMorph;
		fullBounds; "to force a layout compute needed by the textMorphs's autoFit"
		addMorphBack: m
! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 17:16'!
advancedOptionsSelected
	self preferenceView offerPreferenceNameMenu: self model! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 17:06'!
basicButton
	| button |
	button := SimpleButtonMorph new.
	button
		borderWidth: 1;
		borderColor: self paneColor;
		on: #mouseEnter send: #value to: [button borderWidth: 2];
		on: #mouseLeave send: #value to: [button borderWidth: 1];
		vResizing: #rigid;
		height: (TextStyle defaultFont height + 4);
		useSquareCorners;
		clipSubmorphs: true;
		color: self paneColor muchLighter;
		target: self.
	^button! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:59'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 0;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:29'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:43'!
caseInsensitiveBeginsWith: prefix in: string
	^(string findString: prefix startingAt: 1 caseSensitive: false) = 1! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'hpt 12/8/2004 15:55'!
highlightOff
	self beTransparent.
	self label color: Color black.
	self removeExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'highlighting' stamp: 'hpt 12/8/2004 17:25'!
highlightOn
	self color: (Color gray alpha: 0.1).
	self label color: Color red.
	self addExtraControls.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 16:42'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeLayout
	self layoutPolicy: TableLayout new;
		beTransparent;
		layoutInset: 0;
		cellInset: 0;
		listCentering: #topLeft;
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.		! !

!PBPreferenceButtonMorph methodsFor: 'initialization' stamp: 'hpt 12/8/2004 15:38'!
initializeWithPreference: aPreference model: aModel
	preference := aPreference.
	model := aModel.
	self initializeLayout.
	self addMorphBack: self preferenceMorphicView.
	self highlightOff.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:42'!
label
	^self preferenceMorphicView firstSubmorph! !

!PBPreferenceButtonMorph methodsFor: 'accessing' stamp: 'hpt 12/8/2004 15:34'!
model
	^model! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 18:17'!
moreButton
	^moreButton ifNil: 
		[moreButton := self basicButton 
						label: 'more' translated; 
						setBalloonText: 
							'Click here for advanced options'translated;
						actionSelector: #advancedOptionsSelected]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'stephaneducasse 2/4/2006 20:39'!
paneColor
	| browser |
	browser := (self ownerChain 
		detect: [:ea | ea isKindOf: PreferenceBrowserMorph] 
		ifNone: [^Color black]) .
	^browser paneColor! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:13'!
preference
	^preference! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:56'!
preferenceHelp
	| help name |
	help := self preference helpString withBlanksTrimmed.
	name := self preference name.
	(self caseInsensitiveBeginsWith: name  in: help)
		ifTrue: [help := help allButFirst: name size].
	(help notEmpty and: [help first = $:])
		ifTrue: [help := help allButFirst].
	^help withBlanksTrimmed.
! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'hpt 12/8/2004 15:25'!
preferenceHelpText
	^self preferenceHelp asText
		addAttribute: TextEmphasis italic;
		yourself.! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceHelpTextMorph
	| text tm |
	text := self preferenceHelpText.
	tm := TextMorph new
		contents: text;
		wrapOnOff;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		lock: true;
		visible: text notEmpty;
		yourself. "we don't want an empty textmorph showing"
	tm isAutoFit
		ifFalse: [tm autoFitOnOff].
	^tm.! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'AlainPlantec 12/11/2009 06:55'!
preferenceMorphicView
	^ preferenceMorphicView
		ifNil: [preferenceMorphicView := self preferenceView
						representativeButtonWithColor: (preference isMigratedToSetting
								ifTrue: [Color green muchLighter]
								ifFalse: [preference isNotMigratedToSetting
										ifTrue: [Color red muchLighter]
										ifFalse: [preference isSemiMigratedToSetting
										ifTrue: [Color blue muchLighter]
										ifFalse: [preference isObsolete
										ifTrue: [Color gray muchLighter]
										ifFalse: [Color transparent]]]])
						inPanel: self model. 
			preferenceMorphicView hResizing: #spaceFill.
			^ preferenceMorphicView]! !

!PBPreferenceButtonMorph methodsFor: 'preference accessing' stamp: 'stephaneducasse 2/4/2006 20:39'!
preferenceView
	^preferenceView
		ifNil: [preferenceView := self preference viewForPanel: self model.]! !

!PBPreferenceButtonMorph methodsFor: 'extra controls' stamp: 'hpt 12/8/2004 16:40'!
removeExtraControls
	self submorphs copyWithoutFirst do: [:ea | ea delete]! !

!PBPreferenceButtonMorph methodsFor: 'utility methods' stamp: 'hpt 12/8/2004 15:27'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

Object subclass: #CuvierMorphPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!CuvierMorphPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/4/2010 13:49'!
initialize
	"CurvierMorphPreferences initialize"
	Preferences
		preferenceAt: #Curvier
		ifAbsent: [Preferences
				addPreference: #Curvier
				category: #morphic
				default: true
				balloonHelp: 'if true, closed CurvierMorphs will be smoother and more symmetrical all about. If false they will mimic the old curve shapes with the one sharp bend.'].
! !

Object subclass: #DeprecationPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!DeprecationPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/4/2010 13:51'!
initialize
	"DeprecationPreferences initialize"
	Preferences
		addBooleanPreference: #showDeprecationWarnings 
		category: #general "programming?" 
		default: true
		balloonHelp: 'If enabled, use of deprecated APIs is reported to the transcript.'.
	Preferences
		addBooleanPreference: #raiseDeprecatedWarnings 
		category: #general "programming?" 
		default: true
		balloonHelp: 'If enabled, use of a deprecated API raises a Deprecated warning.'.! !

Object subclass: #FreeTypePreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
freeTypeCacheSizePreferenceChanged
	FreeTypeCache current 
		maximumSize: Preferences FreeTypeCacheSize * 1024
	! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
glyphContrastPreferenceChanged	" value between 1 and 100.
	100 is highest contrast and maps to gamma 0.25
	1 is lowest contrast and maps to gamma 2.22"
	| v g |
	v := (((Preferences GlyphContrast asNumber) min: 100) max: 1) asFloat.
	(v closeTo: 50.0) 
		ifTrue:[g := 1.0]
		ifFalse:[g := ((100 - v)+50/100.0) raisedTo: 2].
	FreeTypeSettings current setGamma: g.
	World restoreMorphicDisplay.
! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
hintingFullPreferenceChanged
	Preferences HintingFull
		ifTrue:[Preferences disable: #HintingNone; disable: #HintingLight; disable: #HintingNormal]
		ifFalse:[
			(Preferences HintingNone or:[Preferences HintingLight or:[Preferences HintingNormal]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingFull]].
	FreeTypeSettings current hintingSymbol: #Full
	
		
! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
hintingLightPreferenceChanged
	Preferences HintingLight
		ifTrue:[Preferences disable: #HintingFull; disable: #HintingNone; disable: #HintingNormal]
		ifFalse:[
			(Preferences HintingFull or:[Preferences HintingNone or:[Preferences HintingNormal]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingLight]].
	FreeTypeSettings current hintingSymbol: #Light
	
		
! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
hintingNonePreferenceChanged
	Preferences HintingNone
		ifTrue: [Preferences disable: #HintingFull; disable: #HintingLight; disable: #HintingNormal]
		ifFalse:[(Preferences HintingFull or:[Preferences HintingLight or:[Preferences HintingNormal]])
				ifFalse:[^Preferences enable: #HintingNone]].
	FreeTypeSettings current hintingSymbol: #None.
	
		
! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:34'!
hintingNormalPreferenceChanged
	Preferences HintingNormal
		ifTrue: [Preferences disable: #HintingNone; disable: #HintingLight; disable: #HintingFull ]
		ifFalse:[
			(Preferences HintingNone or:[Preferences HintingLight or:[Preferences HintingFull]])
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #HintingNormal]].
	FreeTypeSettings current hintingSymbol: #Normal
	
		
! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:43'!
monitorTypeCRTPreferenceChanged
	Preferences MonitorTypeCRT
		ifTrue:[Preferences disable: #MonitorTypeLCD]
		ifFalse:[
			Preferences MonitorTypeLCD
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #MonitorTypeCRT]].
	FreeTypeSettings current subPixelAntiAliasing: Preferences MonitorTypeLCD.
	World restoreMorphicDisplay.
	! !

!FreeTypePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 11:41'!
monitorTypeLCDPreferenceChanged
	Preferences MonitorTypeLCD
		ifTrue:[Preferences disable: #MonitorTypeCRT]
		ifFalse:[
			Preferences MonitorTypeCRT
				ifFalse:[
					"turn it back on again"
					^Preferences enable: #MonitorTypeLCD]].
	FreeTypeSettings current subPixelAntiAliasing: Preferences MonitorTypeLCD.
	World restoreMorphicDisplay.! !

Object subclass: #LocalePreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!LocalePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:24'!
initialize
	Preferences
		addPreference: #useLocale
		categories: #('general' )
		default: false
		balloonHelp: 'Use the system locale to set the system language etc at startup'! !

Object subclass: #MCConfigurationPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!MCConfigurationPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:25'!
initialize
	"MCConfiguration initialize"
	Preferences
		addPreference: #upgradeIsMerge
		categories: #('updates' )
		default: false
		balloonHelp: 'When upgrading packages, use merge instead of load'! !

Object subclass: #MorphicPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!MorphicPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:27'!
initialize
	Preferences
		addPreference: #editableStringMorphs
		categories: #(#morphic )
		default: false
		balloonHelp: 'Determines whether shift-clicking on a string morph will make the text editable.'.
	Preferences setParameter: #menuTitleBorderWidth to: 0.
		
	Preferences setParameter: #menuTitleColor
		to: (TranslucentColor
				r: 0.87
				g: 0.8
				b: 1
				alpha: 0.65).
		
	Preferences setParameter: #menuColor
		to: (Color
				r: (215 / 255) asFloat
				g: (220 / 255) asFloat
				b: (232 / 255) asFloat).
! !

Object subclass: #NetworkPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!NetworkPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:19'!
initialize
	Preferences
		addTextPreference: #httpProxyServer
		category: #'http proxy'
		default: ''
		balloonHelp: 'HTTP Proxy Server. Leave blank if you don''t want to use a Proxy'.
	Preferences
		addNumericPreference: #httpProxyPort
		category: #'http proxy'
		default: 80
		balloonHelp: 'HTTP Proxy Port' ! !

Object subclass: #Preference
	instanceVariableNames: 'name value defaultValue helpString localToProject categoryList changeInformee changeSelector viewRegistry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Core'!

!Preference commentStamp: '<historical>' prior: 0!
Represents a true/false flag that is under user control and which can be interrogated by a call to Preferences
	viewRegistry		the registry of the classes responsible for building my view
	name 				a symbol, the formal name of the preference.
	value				a boolean, the current value
	defaultValue		the default value of the preference
	helpString 			string or text, constituting the help message
	localToProject		boolean, whether each project holds its own version
	categoryList			list of categories under which to offer this
	changeInformee 	whom, if anyone, to inform if the value changes:
	changeSelector 		what selector to send to the changeInformee when the value changes!

!Preference methodsFor: 'menu' stamp: 'sw 4/12/2001 23:42'!
categoryList
	"Answer the categoryList"

	^ categoryList! !

!Preference methodsFor: 'initialization' stamp: 'sw 4/29/2001 23:51'!
categoryList: aList
	"Set the receiver's categoryList"

	categoryList := aList! !

!Preference methodsFor: 'change notification' stamp: 'michael.rueger 4/27/2009 18:00'!
changeInformee

	^changeInformee! !

!Preference methodsFor: 'initialization' stamp: 'michael.rueger 4/27/2009 17:54'!
changeInformee: informee
	"Set the object to be informed when my value changes"

	changeInformee := (informee == nil or: [informee == #nil])
						ifTrue: [nil]
						ifFalse:	[(informee isKindOf: Symbol)
							ifTrue:
								[Smalltalk at: informee]
							ifFalse:
								[informee]]! !

!Preference methodsFor: 'change notification' stamp: 'sw 4/12/2001 01:39'!
changeInformee: informee changeSelector: aSelector
	"Set the changeInformee and changeSelector as specified"

	changeInformee := informee.
	changeSelector := aSelector! !

!Preference methodsFor: 'menu' stamp: 'sw 4/13/2001 00:01'!
copyName
	"Copy the name of the given preference to the clipboard"

	Clipboard clipboardText: name asString asText! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 1/8/2010 00:14'!
defaultValue
	"Answer this preference's defaultValue "

	^ defaultValue! !

!Preference methodsFor: 'value' stamp: 'sw 4/18/2002 12:15'!
defaultValue: aValue
	"Set the receiver's defaultValue"

	defaultValue := aValue.! !

!Preference methodsFor: 'menu' stamp: 'sw 4/13/2001 00:04'!
helpString
	"Answer the help string provided for the receiver"

	^ helpString ifNil: ['no help available']! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/11/2009 08:25'!
isMigratedToSetting
	"hack which is to make the old Preferences browser work with
	the new setting framework - Alain Plantec"
	| selector |
	selector := (self name , 'Setting:') asSymbol.
	^ (Preferences respondsTo: selector)
		and: [(Preferences class methodsInCategory: #'settings-migration')
				includes: selector]! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/11/2009 08:29'!
isNotMigratedToSetting
	"hack to show which preferences are not migrated - Alain
	Plantec"
	| selector |
	selector := self name asSymbol.
	^ (Preferences respondsTo: selector)
		and: [(Preferences class methodsInCategory: #'settings-no-migration')
				includes: selector]! !

!Preference methodsFor: 'testing' stamp: 'ar 9/27/2005 21:50'!
isObsolete
	^(changeInformee class isObsolete or:[changeInformee isBehavior and:[changeInformee isObsolete]])! !

!Preference methodsFor: 'local to project' stamp: 'sw 4/10/2001 12:37'!
isProjectLocalString
	"Answer a string representing whether sym is a project-local preference or not"

	| aStr |
	aStr :=  'each project has its own setting'.
	^ localToProject
		ifTrue:
			['<yes>', aStr]
		ifFalse:
			['<no>', aStr]! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/11/2009 08:26'!
isSemiMigratedToSetting
	"hack to show which preferences are kept (class variable) but
	with no setting - Alain Plantec"
	| selector |
	selector := (self name , 'Setting') asSymbol.
	^ (Preferences  respondsTo: selector)
		and: [(Preferences class methodsInCategory: #'settings-semi-migration')
				includes: selector]! !

!Preference methodsFor: 'local to project' stamp: 'sw 4/10/2001 01:14'!
localToProject
	"Answer whether this preference is project-local"

	^ localToProject! !

!Preference methodsFor: 'menu' stamp: 'sw 4/10/2001 15:02'!
name
	"Answer this preference's name"

	^ name! !

!Preference methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:59'!
name: aName defaultValue: aValue helpString: aString localToProject: projectBoolean categoryList: aList changeInformee: informee changeSelector:  aChangeSelector viewRegistry: aViewRegistry
	"Initialize the preference from the given values.  There is an extra tolerence here for the symbols #true, #false, and #nil, which are interpreted, when appropriate, as meaning true, false, and nil"

	name := aName asSymbol.
	defaultValue := aValue.
	aValue = #true ifTrue: [defaultValue := true].
	aValue = #false ifTrue: [defaultValue := false].
	value := defaultValue.
	helpString := aString.
	localToProject := projectBoolean == true or: [projectBoolean = #true].
	viewRegistry := aViewRegistry.
	categoryList := (aList ifNil: [OrderedCollection with: #unclassified]) collect:
		[:elem | elem asSymbol].

	changeInformee := (informee == nil or: [informee == #nil])
						ifTrue: [nil]
						ifFalse:	[(informee isKindOf: Symbol)
							ifTrue:
								[Smalltalk at: informee]
							ifFalse:
								[informee]].
	changeSelector  := aChangeSelector! !

!Preference methodsFor: 'change notification' stamp: 'AlainPlantec 12/17/2009 10:15'!
notifyInformeeOfChange
	"If there is a changeInformee, notify her that I have changed value"
	(Preferences respondsTo: (self name, 'Setting:') asSymbol) 
		ifFalse: [changeInformee ifNotNil: [changeInformee perform: changeSelector]]! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/8/2009 10:58'!
preferenceValue
	"Answer the current value of the preference"

	^ self settingValue! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/8/2009 10:29'!
preferenceValue: aValue
	"set the value as indicated, and invoke the change selector if appropriate"

	| oldValue |
	self settingValue: aValue.
	oldValue := value.
	value := aValue.
	oldValue ~~ value ifTrue:
		[self notifyInformeeOfChange]! !

!Preference methodsFor: 'debugging' stamp: 'sw 4/13/2001 00:05'!
printOn: aStream
	"Print a string decribing the receiver to the given stream"

	super printOn: aStream.
	aStream nextPutAll: name storeString, ' ', value storeString! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/8/2009 10:29'!
rawValue: aValue
	"set the value as indicated, with no side effects"

	self settingValue: aValue.
	value := aValue.! !

!Preference methodsFor: 'user interface' stamp: 'hpt 9/26/2004 16:58'!
representativeButtonWithColor: aColor inPanel: aPanel
	| view |
	view := self viewForPanel: aPanel.
	^view ifNotNil: [view representativeButtonWithColor: aColor inPanel: aPanel]! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/8/2009 10:29'!
restoreDefaultValue
	"restore the default value to the preference"

	self settingValue: defaultValue.
	value := defaultValue! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/11/2009 08:24'!
settingValue
	"hack which is to make the old Preferences browser work with
	the new setting framework - Alain Plantec"
	^ (Preferences respondsTo: (self name , 'Setting') asSymbol)
		ifTrue: [Preferences perform: (self name , 'Setting') asSymbol]
		ifFalse: [value] ! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/17/2009 10:12'!
settingValue: aValue
	"hack which is to make the old Preferences browser work with the new setting framework - Alain Plantec"
	(Preferences respondsTo: (self name, 'Setting:') asSymbol) 
		ifTrue: [Preferences perform: (self name, 'Setting:') asSymbol with: aValue. 
			^ true].
	^ false! !

!Preference methodsFor: 'change notification' stamp: 'AlainPlantec 12/17/2009 10:19'!
settingsMigrationCheck
	(Preferences respondsTo: (self name, 'Setting:') asSymbol) 
		ifTrue: [changeInformee 
			ifNotNil: [Transcript show: changeInformee name, ' '.
				Transcript show: changeSelector, String cr]].! !

!Preference methodsFor: 'value' stamp: 'AlainPlantec 12/8/2009 10:29'!
togglePreferenceValue
	"Toggle whether the value of the preference. Self must be a boolean preference."
	value := value not.
	self settingValue: value.
	self notifyInformeeOfChange! !

!Preference methodsFor: 'local to project' stamp: 'alain.plantec 6/6/2009 14:23'!
toggleProjectLocalness
	"Toggle whether the preference should be held project-by-project or globally"

	localToProject := localToProject not.
! !

!Preference methodsFor: 'user interface' stamp: 'hpt 9/26/2004 15:42'!
viewClassForPanel: aPreferencePanel
	^self viewRegistry viewClassFor: aPreferencePanel! !

!Preference methodsFor: 'user interface' stamp: 'hpt 9/26/2004 16:58'!
viewForPanel: aPreferencePanel
	| viewClass |
	viewClass := self viewClassForPanel: aPreferencePanel.
	^viewClass ifNotNil: [viewClass preference: self]! !

!Preference methodsFor: 'user interface' stamp: 'hpt 9/26/2004 15:40'!
viewRegistry
	^viewRegistry! !

!Preference methodsFor: 'user interface' stamp: 'hpt 9/26/2004 15:40'!
viewRegistry: aRegistry
	viewRegistry := aRegistry! !

Object subclass: #PreferenceView
	instanceVariableNames: 'preference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

PreferenceView class
	instanceVariableNames: 'registeredClasses'!

!PreferenceView commentStamp: '<historical>' prior: 0!
My subclasses instances are responsible for building the visual representation of each kind of preference.!

PreferenceView class
	instanceVariableNames: 'registeredClasses'!

PreferenceView subclass: #BooleanPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!BooleanPreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the visual representation of a preference that accepts true and false values!

!BooleanPreferenceView classSide methodsFor: 'view registry' stamp: 'alain.plantec 6/6/2009 22:38'!
handlesPanel: aPreferencePanel
	^false! !

!BooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:55'!
initialize
	PreferenceViewRegistry ofBooleanPreferences register: self.! !

!BooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:55'!
unload
	PreferenceViewRegistry ofBooleanPreferences unregister: self.! !

!BooleanPreferenceView methodsFor: 'user interface' stamp: 'alain.plantec 5/30/2008 09:57'!
offerPreferenceNameMenu: aPanel with: ignored1 in: ignored2
	"the user clicked on a preference name -- put up a menu"

	| aMenu |
	ActiveHand showTemporaryCursor: nil.
	aMenu := MenuMorph new defaultTarget: self preference.
	aMenu addTitle: self preference name.

	(Preferences okayToChangeProjectLocalnessOf: self preference name) ifTrue:
		[aMenu addUpdating: #isProjectLocalString target: self preference action: #toggleProjectLocalness.
		aMenu balloonTextForLastItem: 'Some preferences are best applied uniformly to all projects, and others are best set by each individual project.  If this item is checked, then this preference will be printed in bold and will have a separate value for each project'].

	aMenu add: 'browse senders' target: self systemNavigation selector: #browseAllCallsOn: argument: self preference name.
	aMenu balloonTextForLastItem: 'This will open a method-list browser on all methods that the send the preference "', self preference name, '".'. 
	aMenu add: 'show category...' target: aPanel selector: #findCategoryFromPreference: argument: self preference name.
	aMenu balloonTextForLastItem: 'Allows you to find out which category, or categories, this preference belongs to.'.

	aMenu add: 'hand me a button for this preference' target: self selector: #tearOffButton.
	aMenu balloonTextForLastItem: 'Will give you a button that governs this preference, which you may deposit wherever you wish'.

	aMenu add: 'copy this name to clipboard' target: self preference selector: #copyName.
	aMenu balloonTextForLastItem: 'Copy the name of the preference to the text clipboard, so that you can paste into code somewhere'.

	aMenu popUpInWorld! !

!BooleanPreferenceView methodsFor: 'user interface' stamp: 'md 9/5/2005 15:40'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	"Return a button that controls the setting of prefSymbol.  It will keep up to date even if the preference value is changed in a different place"

	| outerButton aButton str miniWrapper |
	
	outerButton := AlignmentMorph newRow height: 24.
	outerButton color:  (aColor ifNil: [Color r: 0.645 g: 1.0 b: 1.0]).
	outerButton hResizing: (aPreferencesPanel ifNil: [#shrinkWrap] ifNotNil: [#spaceFill]).
	outerButton vResizing: #shrinkWrap.
	outerButton addMorph: (aButton := UpdatingThreePhaseButtonMorph checkBox).
	aButton
		target: self preference;
		actionSelector: #togglePreferenceValue;
		getSelector: #preferenceValue.

	outerButton addTransparentSpacerOfSize: (2 @ 0).
	str := StringMorph contents: self preference name font: (StrikeFont familyName: 'NewYork' size: 12).

	self preference localToProject ifTrue:
		[str emphasis: TextEmphasis bold emphasisCode].

	miniWrapper := AlignmentMorph newRow hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	miniWrapper beTransparent addMorphBack: str lock.
	aPreferencesPanel
		ifNotNil:  "We're in a Preferences panel"
			[miniWrapper on: #mouseDown send: #offerPreferenceNameMenu:with:in: to: self withValue: aPreferencesPanel.
			miniWrapper on: #mouseEnter send: #menuButtonMouseEnter: to: miniWrapper.
			miniWrapper on: #mouseLeave send: #menuButtonMouseLeave: to: miniWrapper.
			miniWrapper setBalloonText: 'Click here for a menu of options regarding this preference.  Click on the checkbox to the left to toggle the setting of this preference']

		ifNil:  "We're a naked button, not in a panel"
			[miniWrapper setBalloonText: self preference helpString; setProperty: #balloonTarget toValue: aButton].

	outerButton addMorphBack: miniWrapper.
	outerButton setNameTo: self preference name.

	aButton setBalloonText: self preference helpString.

	^ outerButton

	"(Preferences preferenceAt: #balloonHelpEnabled) view tearOffButton"! !

PreferenceView subclass: #HaloThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!HaloThemePreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the view for the preference that choose the halo theme!

!HaloThemePreferenceView classSide methodsFor: 'view registry' stamp: 'alain.plantec 6/6/2009 22:38'!
handlesPanel: aPreferencePanel
	^false! !

!HaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:58'!
initialize
	"adding the halo theme preference to Preferences and registering myself as its view"
	PreferenceViewRegistry ofHaloThemePreferences register: self.
	Preferences 
		addPreference: #haloTheme 
		categories: {#halos} 
		default: #iconicHaloSpecifications
		balloonHelp: ''
		projectLocal: false
		changeInformee: nil
		changeSelector: nil
		viewRegistry: PreferenceViewRegistry ofHaloThemePreferences.! !

!HaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:58'!
unload
	PreferenceViewRegistry ofHaloThemePreferences unregister: self.! !

!HaloThemePreferenceView methodsFor: 'user interface' stamp: 'AlainPlantec 1/7/2010 22:13'!
haloThemeRadioButtons
	"Answer a column of butons representing the choices of halo theme"

	| buttonColumn aRow aRadioButton aStringMorph |
	buttonColumn := AlignmentMorph newColumn beTransparent.
	#(	(iconicHaloSpecifications iconic iconicHalosInForce	'circular halos with icons inside')
		(classicHaloSpecifications	classic	classicHalosInForce		'plain circular halos')
		(customHaloSpecifications	custom	customHalosInForce		'customizable halos')) do:

		[:quad |
			aRow := AlignmentMorph newRow beTransparent.
			aRow addMorph: (aRadioButton := UpdatingThreePhaseButtonMorph radioButton).
			aRadioButton target: Preferences.
			aRadioButton setBalloonText: quad fourth.
			aRadioButton actionSelector: #installHaloTheme:.
			aRadioButton getSelector: quad third.
			aRadioButton arguments: (Array with: quad first).
			aRow addTransparentSpacerOfSize: (4 @ 0).
			aRow addMorphBack: (aStringMorph := StringMorph contents: quad second asString).
			aStringMorph setBalloonText: quad fourth.
			buttonColumn addMorphBack: aRow].
	^ buttonColumn

	"(Preferences preferenceAt: #haloTheme) view tearOffButton"! !

!HaloThemePreferenceView methodsFor: 'user interface' stamp: 'hpt 9/24/2004 23:11'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	| outerButton editButton |
	editButton := SimpleButtonMorph new 
					target: Preferences; 
					color: Color transparent; 
					actionSelector: #editCustomHalos; 
					label: 'Edit custom halos' translated;
					setBalloonText: 'Click here to edit the method that defines the custom halos' translated.
	
	outerButton := AlignmentMorph newColumn.
	outerButton
		color:  (aColor ifNil: [Color r: 0.645 g: 1.0 b: 1.0]);
		hResizing: (aPreferencesPanel ifNil: [#shrinkWrap] ifNotNil: [#spaceFill]);
		vResizing: #shrinkWrap;	
		addTransparentSpacerOfSize: (0@4);
		addMorphBack: self haloThemeRadioButtons;
		addTransparentSpacerOfSize: (0@4);
		addMorphBack: editButton.
		
	^outerButton.
	
	"(Preferences preferenceAt: #haloTheme) view tearOffButton"	! !

PreferenceView subclass: #PBPreferenceView
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBPreferenceView commentStamp: '<historical>' prior: 0!
I am just a refactor of all the common method of the PreferenceBrowser preference views!

PBPreferenceView subclass: #PBBooleanPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBBooleanPreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the visual representation of a preference that accepts true and false values. This view is aimed to be used inside a PreferenceBrowser panel.!

!PBBooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:47'!
initialize
	PreferenceViewRegistry ofBooleanPreferences register: self.
! !

!PBBooleanPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:47'!
unload
	PreferenceViewRegistry ofBooleanPreferences unregister: self.! !

!PBBooleanPreferenceView methodsFor: 'Polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:38'!
enabledButton
	"Answer a checkbox for the enablement state."
	
	^UITheme current
		newCheckboxIn: World
		for: self preference
		getSelected: #preferenceValue
		setSelected: #preferenceValue:
		getEnabled: nil
		label: 'enabled' translated
		help: nil! !

!PBBooleanPreferenceView methodsFor: 'Polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:40'!
localToProjectButton
	"Answer a checkbox for the local enablement state."
	
	^UITheme current
		newCheckboxIn: World
		for: self preference
		getSelected: #localToProject
		setSelected: #toggleProjectLocalness
		getEnabled: nil
		label: 'local' translated
		help: nil
		! !

!PBBooleanPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:25'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	^self horizontalPanel
		layoutInset: 2;
		cellInset: 7;
		color: aColor;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self horizontalFiller; 
		addMorphBack: self enabledButton;
		addMorphBack: self localToProjectButton;
		yourself.! !

PBPreferenceView subclass: #PBColorPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/6/2004 20:49'!
initialize
	PreferenceViewRegistry ofColorPreferences register: self.! !

!PBColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/6/2004 20:49'!
unload
	PreferenceViewRegistry ofColorPreferences unregister: self.! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/6/2004 21:24'!
colorSwatch
	^UpdatingRectangleMorph new
		target: self preference;
		getSelector: #preferenceValue;
		putSelector: #preferenceValue:;
		extent: 22@22;
		setBalloonText: 'click here to change the color' translated;
		yourself.! !

!PBColorPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/6/2004 21:12'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self horizontalFiller;
		addMorphBack: self colorSwatch;
		yourself! !

PBColorPreferenceView subclass: #PBWindowColorPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
initialize
	self viewRegistry register: self.! !

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
unload
	self viewRegistry unregister: self.! !

!PBWindowColorPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/8/2004 18:40'!
viewRegistry
	^(PreferenceViewRegistry registryOf: #windowColorPreferences)
		viewOrder: 6;
		yourself.! !

!PBWindowColorPreferenceView methodsFor: 'initialization' stamp: 'AlainPlantec 12/16/2009 21:24'!
initialize
	super initialize.
! !

PBPreferenceView subclass: #PBHaloThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBHaloThemePreferenceView commentStamp: '<historical>' prior: 0!
I am responsible for building the button for the Halo Theme preference!

!PBHaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:48'!
initialize
	PreferenceViewRegistry ofHaloThemePreferences register: self.! !

!PBHaloThemePreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 15:48'!
unload
	PreferenceViewRegistry ofHaloThemePreferences unregister: self.! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'nice 1/5/2010 15:59'!
haloThemeRadioButtons
	"Answer a column of butons representing the choices of halo theme"

	| buttonColumn |
	buttonColumn := self verticalPanel.
	#(	(iconicHaloSpecifications iconic iconicHalosInForce	'circular halos with icons inside')
		(classicHaloSpecs	classic	classicHalosInForce		'plain circular halos')
		(customHaloSpecs	custom	customHalosInForce		'customizable halos')) do:

		[:quad | | aRadioButton aRow aLabel |
			aRadioButton := UpdatingThreePhaseButtonMorph radioButton
				target: Preferences;
				setBalloonText: quad fourth;
				actionSelector: #installHaloTheme:;
				getSelector: quad third;
				arguments: (Array with: quad first);
				yourself.
			aLabel := (StringMorph contents: quad second asString)
						setBalloonText: quad fourth;
						yourself.
			aRow := self horizontalPanel
				cellInset: 4;
				addMorphBack: aRadioButton;
				addMorphBack: aLabel.
			buttonColumn addMorphBack: aRow].
	^ buttonColumn

	"(Preferences preferenceAt: #haloTheme) view tearOffButton"! !

!PBHaloThemePreferenceView methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 10:13'!
initialize
	super initialize.
	self addActionTitled: 'edit custom halos' 
		target: Preferences 
		selector:  #editCustomHalos 
		arguments: {} 
		balloonText: 'Click here to edit the method that defines the custom halos' translated.! !

!PBHaloThemePreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:45'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	| innerPanel |
	innerPanel := self horizontalPanel
		addMorphBack: (self blankSpaceOf: 10@0);
		addMorphBack: self haloThemeRadioButtons;
		yourself.
	^self verticalPanel
		color: aColor;
		layoutInset: 2;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: innerPanel.! !

PBPreferenceView subclass: #PBNumericPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBNumericPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/9/2004 22:21'!
initialize
	PreferenceViewRegistry ofNumericPreferences register: self.! !

!PBNumericPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 12/9/2004 22:21'!
unload
	PreferenceViewRegistry ofNumericPreferences unregister: self.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/9/2004 22:23'!
preferenceValue
	^self preference preferenceValue asString! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:53'!
preferenceValue: aTextOrString
	(aTextOrString notEmpty and: [aTextOrString asString isAllDigits])
		ifFalse: [^false].
	self preference preferenceValue: aTextOrString asNumber.
	^true.! !

!PBNumericPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/9/2004 22:19'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self textField;
		yourself.! !

!PBNumericPreferenceView methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:27'!
textField
	"Answer a text field for the preference."
	
	^UITheme current
		newAutoAcceptTextEntryIn: World
		for: self
		get: #preferenceValue
		set: #preferenceValue:
		class: String
		getEnabled: nil
		help: nil! !

!PBPreferenceView classSide methodsFor: 'view registry' stamp: 'hpt 9/26/2004 16:09'!
handlesPanel: aPreferencePanel
	^aPreferencePanel isKindOf: PreferenceBrowser! !

!PBPreferenceView methodsFor: 'actions' stamp: 'stephaneducasse 2/4/2006 20:39'!
actions
	^actions ifNil: [actions := OrderedCollection new.]! !

!PBPreferenceView methodsFor: 'actions' stamp: 'hpt 12/8/2004 18:13'!
addActionTitled: aTitle target: aTarget selector: aSelector arguments: aCollection balloonText: aText
	self actions add: { aTitle. aTarget. aSelector. aCollection. aText }! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:42'!
basicPanel
	^BorderedMorph new
		beTransparent;
		extent: 0@0;
		borderWidth: 0;
		layoutInset: 0;
		cellInset: 2;
		layoutPolicy: TableLayout new;
		listCentering: #topLeft;
		cellPositioning: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:15'!
blankSpaceOf: aPoint
	^Morph new 
		beTransparent;
		extent: aPoint; 
		yourself! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 00:13'!
horizontalFiller
	^self horizontalPanel
		hResizing: #spaceFill;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
horizontalPanel
	^self basicPanel
		cellPositioning: #center;
		listDirection: #leftToRight;
		yourself.! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'alain.plantec 5/30/2008 14:00'!
offerPreferenceNameMenu: aPreferenceBrowser
	"the user clicked on a preference name -- put up a menu"

	| aMenu |			
	aMenu := MenuMorph new 
		defaultTarget: self preference;
		addTitle: self preference name.

	(Preferences okayToChangeProjectLocalnessOf: self preference name) ifTrue:
		[aMenu addUpdating: #isProjectLocalString target: self preference action: #toggleProjectLocalness.
		aMenu balloonTextForLastItem: 'Some preferences are best applied uniformly to all projects, and others are best set by each individual project.  If this item is checked, then this preference will be printed in bold and will have a separate value for each project'].

	aMenu add: 'browse senders' translated target: self systemNavigation selector: #browseAllCallsOn: argument: self preference name.
	aMenu balloonTextForLastItem: 'This will open a method-list browser on all methods that the send the preference "', self preference name, '".'. 
	aMenu add: 'show category...' target: aPreferenceBrowser selector: #findCategoryFromPreference: argument: self preference name.
	aMenu balloonTextForLastItem: 'Allows you to find out which category, or categories, this preference belongs to.'.

	aMenu add: 'hand me a button for this preference' target: self selector: #tearOffButton.
	aMenu balloonTextForLastItem: 'Will give you a button that governs this preference, which you may deposit wherever you wish'.

	aMenu add: 'copy this name to clipboard' target: self preference selector: #copyName.
	aMenu balloonTextForLastItem: 'Copy the name of the preference to the text clipboard, so that you can paste into code somewhere'.

	aMenu popUpInWorld! !

!PBPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:43'!
verticalPanel
	^self basicPanel
		cellPositioning: #topLeft;
		listDirection: #topToBottom;
		yourself.! !

PBPreferenceView subclass: #PBTextPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBTextPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 17:01'!
initialize
	PreferenceViewRegistry ofTextPreferences register: self.! !

!PBTextPreferenceView classSide methodsFor: 'initialization' stamp: 'hpt 9/26/2004 17:01'!
unload
	PreferenceViewRegistry ofTextPreferences unregister: self.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 12/10/2004 22:46'!
preferenceValue
	^self preference preferenceValue ifNil: ['']! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:38'!
preferenceValue: aTextOrString
	self preference preferenceValue: aTextOrString asString.
	^true.! !

!PBTextPreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 11:41'!
representativeButtonWithColor: aColor inPanel: aPreferenceBrowser
	^self horizontalPanel
		layoutInset: 2;
		color: aColor;
		cellInset: 20;
		cellPositioning: #center;
		addMorphBack: (StringMorph contents: self preference name);
		addMorphBack: self textField;
		yourself.! !

!PBTextPreferenceView methodsFor: 'polymorph-Widgets-override' stamp: 'gvc 9/7/2007 20:27'!
textField
	"Answer a text field for the preference."
	
	^UITheme current
		newAutoAcceptTextEntryIn: World
		for: self
		get: #preferenceValue
		set: #preferenceValue:
		class: String
		getEnabled: nil
		help: nil! !

PBPreferenceView subclass: #PBUIThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBUIThemePreferenceView commentStamp: 'gvc 7/16/2007 13:51' prior: 0!
PreferenceBrowser support for selecting a UITheme.!

PBUIThemePreferenceView subclass: #PBSoundThemePreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

!PBSoundThemePreferenceView commentStamp: 'gvc 9/23/2008 11:53' prior: 0!
PreferenceBrowser support for selecting a SoundTheme.!

!PBSoundThemePreferenceView classSide methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:18'!
initialize
	"Inititalize the class.
	Register with the PreferenceViewRegistry for ui sound themes."
	
	PreferenceViewRegistry ofSoundThemePreferences register: self.
	Preferences 
		addPreference: #soundTheme 
		categories: #(morphic windows)
		default: SoundTheme
		balloonHelp: 'The sound theme used for user interface events.'
		projectLocal: false
		changeInformee: nil
		changeSelector: nil
		viewRegistry: PreferenceViewRegistry ofSoundThemePreferences! !

!PBSoundThemePreferenceView classSide methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:17'!
unload
	"Unload the class.
	Unregister with the PreferenceViewRegistry for sound themes."
	
	PreferenceViewRegistry ofSoundThemePreferences unregister: self! !

!PBSoundThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:10'!
allThemeClasses
	"Answer the classes that may chosen for the theme."

	^SoundTheme allThemeClasses! !

!PBSoundThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 1/31/2009 16:18'!
preferenceName
	"Answer the label to use for this preference."
	
	^'Sound Theme' translated! !

!PBUIThemePreferenceView classSide methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:19'!
initialize
	"Inititalize the class.
	Register with the PreferenceViewRegistry for ui themes."
	
	PreferenceViewRegistry ofUIThemePreferences register: self.
	Preferences 
		addPreference: #uiTheme 
		categories: #(morphic windows)
		default: UIThemeStandardSqueak
		balloonHelp: 'The style of user interface to use.'
		projectLocal: false
		changeInformee: nil
		changeSelector: nil
		viewRegistry: PreferenceViewRegistry ofUIThemePreferences! !

!PBUIThemePreferenceView classSide methodsFor: 'as yet unclassified' stamp: 'gvc 6/22/2007 15:23'!
unload
	"Unload the class.
	Unregister with the PreferenceViewRegistry for ui themes."
	
	PreferenceViewRegistry ofUIThemePreferences unregister: self! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:10'!
allThemeClasses
	"Answer the classes that may chosen for the theme."

	^UITheme allThemeClasses! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 9/7/2007 20:51'!
newRadioButtonFor: aThemeClass
	"Answer radio button for selecting a theme"

	^UITheme current
		newRadioButtonIn: World
		for: aThemeClass
		getSelected: #isCurrent
		setSelected: #beCurrent
		getEnabled: nil
		label: aThemeClass themeName
		help: ('Use the {1} theme' translated format: {aThemeClass themeName})! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 1/31/2009 16:18'!
preferenceName
	"Answer the label to use for this preference."
	
	^'UI Theme' translated! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 1/31/2009 16:18'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	"Answer the morph for the panel."
	
	| innerPanel |
	innerPanel := self horizontalPanel
		addMorphBack: (self blankSpaceOf: 10@0);
		addMorphBack: self uiThemeRadioButtons;
		yourself.
	^self verticalPanel
		color: aColor;
		layoutInset: 2;
		addMorphBack: (StringMorph contents: self preferenceName);
		addMorphBack: innerPanel! !

!PBUIThemePreferenceView methodsFor: 'as yet unclassified' stamp: 'gvc 9/12/2007 15:07'!
uiThemeRadioButtons
	"Answer a column of butons representing the choices of ui theme"

	| buttonColumn |
	buttonColumn := self verticalPanel.
	self allThemeClasses do: [:c |
		buttonColumn addMorphBack: (self newRadioButtonFor: c)].
	^buttonColumn! !

!PreferenceView classSide methodsFor: 'view registry' stamp: 'hpt 9/26/2004 16:09'!
handlesPanel: aPreferencePanel
	self subclassResponsibility ! !

!PreferenceView classSide methodsFor: 'instance creation' stamp: 'hpt 9/24/2004 22:25'!
preference: aPreference
	^self new
		initializeWithPreference: aPreference;
		yourself! !

!PreferenceView methodsFor: 'initialization' stamp: 'hpt 9/24/2004 22:25'!
initializeWithPreference: aPreference
	preference := aPreference! !

!PreferenceView methodsFor: 'accessing' stamp: 'hpt 9/24/2004 22:25'!
preference
	^preference! !

!PreferenceView methodsFor: 'user interface' stamp: 'hpt 9/24/2004 22:56'!
representativeButtonWithColor: aColor inPanel: aPreferencesPanel
	self subclassResponsibility ! !

!PreferenceView methodsFor: 'user interface' stamp: 'hpt 9/26/2004 16:14'!
tearOffButton
	"Hand the user a button the can control this"

	| aButton |
	aButton := self representativeButtonWithColor: self preference defaultBackgroundColor inPanel: nil.
	aButton borderWidth: 1; borderColor:  Color black; useRoundedCorners.
	aButton openInHand! !

Object subclass: #PreferenceViewRegistry
	instanceVariableNames: 'registeredClasses viewOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Browser'!

PreferenceViewRegistry class
	instanceVariableNames: 'registries'!

!PreferenceViewRegistry commentStamp: '<historical>' prior: 0!
PreferenceViewRegistry is much like the AppRegistry classes.  Its purpose is to allow PreferenceBrowser implementers to register its own views for each kind of preference.!

PreferenceViewRegistry class
	instanceVariableNames: 'registries'!

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofBooleanPreferences
	^(self registryOf: #booleanPreferences)
		viewOrder: 1; 
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:24'!
ofColorPreferences
	^(self registryOf: #colorPreferences)
		viewOrder: 5;
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:24'!
ofFontPreferences
	^(self registryOf: #fontPreferences)
		viewOrder: 4;
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofHaloThemePreferences
	^(self registryOf: #haloThemePreferences)
		viewOrder: 2;
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 12/9/2004 22:16'!
ofNumericPreferences
	^(self registryOf: #numericPreferences)
		viewOrder: 3;
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'Polymorph-Widgets' stamp: 'gvc 9/12/2007 15:16'!
ofSoundThemePreferences
	"Answer the sound theme preference registry."
	
	^(self registryOf: #soundThemePreferences)
		viewOrder: 2;
		yourself! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 16:23'!
ofTextPreferences
	^(self registryOf: #textPreferences)
		viewOrder: 3;
		yourself.! !

!PreferenceViewRegistry classSide methodsFor: 'Polymorph-Widgets' stamp: 'gvc 6/22/2007 15:24'!
ofUIThemePreferences
	"Answer the ui theme preference registry."
	
	^(self registryOf: #uiThemePreferences)
		viewOrder: 2;
		yourself! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 15:28'!
registries
	^registries ifNil: [registries := Dictionary new]! !

!PreferenceViewRegistry classSide methodsFor: 'instance creation' stamp: 'hpt 9/26/2004 15:33'!
registryOf: aSymbol
	^self registries at: aSymbol ifAbsentPut: [self new]! !

!PreferenceViewRegistry methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 10:15'!
initialize
	super initialize.
	viewOrder := 1.! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
register: aProviderClass
	(self registeredClasses includes: aProviderClass) 
		ifFalse: [self registeredClasses add: aProviderClass].! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
registeredClasses
	^registeredClasses ifNil: [registeredClasses := OrderedCollection new]! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
unregister: aProviderClass
	self registeredClasses remove: aProviderClass ifAbsent: []! !

!PreferenceViewRegistry methodsFor: 'view registry' stamp: 'hpt 9/26/2004 15:26'!
viewClassFor: aPreferencePanel
	^self registeredClasses 
		detect: [:aViewClass| aViewClass handlesPanel: aPreferencePanel]
		ifNone: [].! !

!PreferenceViewRegistry methodsFor: 'view order' stamp: 'hpt 9/26/2004 16:22'!
viewOrder
	"answer the order in which the registered views should appear relative to the other views"
	^viewOrder! !

!PreferenceViewRegistry methodsFor: 'view order' stamp: 'hpt 9/26/2004 16:22'!
viewOrder: aNumber
	viewOrder := aNumber! !

Object subclass: #Preferences
	instanceVariableNames: ''
	classVariableNames: 'DictionaryOfPreferences Parameters'
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Core'!

!Preferences commentStamp: '<historical>' prior: 0!
A general mechanism to store preference choices.  The default setup treats any symbol as a potential boolean flag; flags unknown to the preference dictionary are always returned as false.  

	To open the control panel:		Preferences openFactoredPanel
	To read how to use the panel (and how to make a preference be per-project):
		 Preferences giveHelpWithPreferences

All messages are on the class side.

To query a a preference:
	Preferences logDebuggerStackToFile
or some people prefer the more verbose
	Preferences valueOfFlag: #logDebuggerStackToFile

You can make up a new preference any time.  Do not define a new message in Preferences class. Accessor methods are compiled automatically when you add a preference as illustrated below:

To add a preference (e.g. in the Postscript of a fileout):
	Preferences addPreference: #samplePreference categories: #(general browsing)
		default: true balloonHelp: 'This is an example of a preference added by a do-it'
		projectLocal: false changeInformee: nil changeSelector: nil.

To change a preference programatically:
	Preferences disable: #logDebuggerStackToFile.
Or to turn it on,
	Preferences enable: #logDebuggerStackToFile.
!

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 08:42'!
Curvier
	^ self CurvierSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:33'!
CurvierSetting
	^ PolygonMorph curvierByDefault! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:34'!
CurvierSetting: aBoolean 
	^ PolygonMorph curvierByDefault: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPConflict
	^ self
		valueOfFlag: #DPConflict
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPDebugging
	^ self
		valueOfFlag: #DPDebugging
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPDuplicated
	^ self
		valueOfFlag: #DPDuplicated
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPLocal
	^ self
		valueOfFlag: #DPLocal
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPLong
	^ self
		valueOfFlag: #DPLong
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPOverride
	^ self
		valueOfFlag: #DPOverride
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPRecentlyModified
	^ self
		valueOfFlag: #DPRecentlyModified
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPRequired
	^ self
		valueOfFlag: #DPRequired
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPSuperSend
	^ self
		valueOfFlag: #DPSuperSend
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPSupplied
	^ self
		valueOfFlag: #DPSupplied
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
DPUncommented
	^ self
		valueOfFlag: #DPUncommented
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 14:59'!
FreeTypeCacheSize
	^FreeTypeCache current cacheSize ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:19'!
FreeTypeCacheSizeSetting
	^FreeTypeCache current cacheSize ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:31'!
FreeTypeCacheSizeSetting: anInteger
	FreeTypeCache current cacheSize:  anInteger! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/8/2009 10:37'!
GlyphContrast
	^ FreeTypeSettings current glyphContrast! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:20'!
GlyphContrastSetting
	^ FreeTypeSettings current glyphContrast! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:37'!
GlyphContrastSetting: aValue
	FreeTypeSettings current glyphContrast: aValue! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:08'!
HintingFull
	^ FreeTypeSettings current hintingSymbol = #Full! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:58'!
HintingFullSetting
	^ FreeTypeSettings current hintingSymbol = #Full! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:33'!
HintingFullSetting: aValue
	aValue 
		ifTrue: [FreeTypeSettings current hintingSymbol: #Full]
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:01'!
HintingLight
	^ FreeTypeSettings current hintingSymbol = #Light! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
HintingLightSetting
	^ FreeTypeSettings current hintingSymbol = #Light! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:34'!
HintingLightSetting: aBoolean
	aBoolean 
		ifTrue: [FreeTypeSettings current hintingSymbol: #Light]
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:01'!
HintingNone
	^ FreeTypeSettings current hintingSymbol = #None! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
HintingNoneSetting
	^ FreeTypeSettings current hintingSymbol = #None! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:35'!
HintingNoneSetting: aBoolean
	aBoolean 
		ifTrue: [FreeTypeSettings current hintingSymbol: #None]
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:02'!
HintingNormal
	^ FreeTypeSettings current hintingSymbol = #Normal! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
HintingNormalSetting
	^ FreeTypeSettings current hintingSymbol = #Normal! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:35'!
HintingNormalSetting: aBoolean
	aBoolean 
		ifTrue: [FreeTypeSettings current hintingSymbol: #Normal]
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:02'!
MonitorTypeCRT
	^ FreeTypeSettings current monitorType = #CRT! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
MonitorTypeCRTSetting
	^ FreeTypeSettings current monitorType = #CRT! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:24'!
MonitorTypeCRTSetting: aBoolean
	aBoolean 
		ifTrue: [FreeTypeSettings current monitorType: #CRT]
		ifFalse: [FreeTypeSettings current monitorType: #LCD]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:02'!
MonitorTypeLCD
	^ FreeTypeSettings current monitorType = #LCD! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
MonitorTypeLCDSetting
	^ FreeTypeSettings current monitorType = #LCD! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:24'!
MonitorTypeLCDSetting: aBoolean
	aBoolean 
		ifTrue: [FreeTypeSettings current monitorType: #LCD]
		ifFalse: [FreeTypeSettings current monitorType: #CRT]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:03'!
UpdateFontsAtImageStartup
	^ FreeTypeSettings updateFontsAtImageStartup! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:32'!
UpdateFontsAtImageStartupSetting
	^ FreeTypeSettings updateFontsAtImageStartup! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:32'!
UpdateFontsAtImageStartupSetting: aBoolean
	FreeTypeSettings updateFontsAtImageStartup: aBoolean! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/18/2009 16:48'!
aaFontsColormapDepth
	"Adjust balance between colored AA text quality (especially if subpixel AA is used) and space / performance.
	5 is optimal quality. Each colorMap takes 128kB of RAM, and takes several seconds to build.
	4 is a reasonable balance. Each colorMap takes 16kB of RAM and builds fast on a fast machine.
	3 is good for slow hardware or memory restrictions. Each colorMap takes 2 kb of RAM."
	^ Color aaFontsColormapDepth! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 2/24/1999 12:26'!
acceptAnnotationsFrom: aSystemWindow
	"This intricate extraction is based on the precise structure of the annotation-request window.  Kindly avert your eyes."
	| aList |
	aList := aSystemWindow paneMorphs first firstSubmorph submorphs collect:
		[:m |  m contents asSymbol].
	self defaultAnnotationRequests: aList
	! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:00'!
addBooleanPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: categoryList  default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofBooleanPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:01'!
addBooleanPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: {categorySymbol} default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofBooleanPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:03'!
addColorPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: categoryList  default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofColorPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:03'!
addColorPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: {categorySymbol} default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofColorPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:03'!
addFontPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: categoryList  default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofFontPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:02'!
addFontPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: {categorySymbol} default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofFontPreferences ! !

!Preferences class methodsFor: 'misc' stamp: 'sw 10/6/1999 15:20'!
addModelItemsToWindowMenu: aMenu
	aMenu addLine.
	aMenu add: 'restore default preference settings' target: self action: #chooseInitialSettings.
	aMenu add: 'restore default text highlighting' target: self action: #initializeTextHighlightingParameters! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 12/9/2004 22:15'!
addNumericPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. "

	self addPreference: prefSymbol  categories: categoryList  default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofNumericPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 12/9/2004 22:15'!
addNumericPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system."

	self addPreference: prefSymbol  categories: {categorySymbol} default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofNumericPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:05'!
addPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"
	self addBooleanPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString.! !

!Preferences class methodsFor: 'add preferences' stamp: 'AlainPlantec 12/17/2009 21:56'!
addPreference: aName categories: categoryList default: aValue balloonHelp: helpString projectLocal: localBoolean changeInformee: informeeSymbol changeSelector: aChangeSelector viewRegistry: aViewRegistry 
	"Add or replace a preference as indicated.  Reuses the preexisting Preference object for this symbol, if there is one, so that UI artifacts that interact with it will remain valid."

	| aPreference aPrefSymbol |
	aPrefSymbol := aName asSymbol.
	aPreference := self dictionaryOfPreferences  at:aPrefSymbol
				 ifAbsent:[Preference new].
	aPreference 
		 name:aPrefSymbol
		 defaultValue:aValue
		 helpString:helpString
		 localToProject:localBoolean
		 categoryList:categoryList
		 changeInformee:informeeSymbol
		 changeSelector:aChangeSelector
		 viewRegistry:aViewRegistry.
	self dictionaryOfPreferences  at:aPrefSymbol  put:aPreference.
	"self  compileAccessMethodForPreference:aPreference"! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:05'!
addPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add the given preference, putting it in the given category, with the given default value, and with the given balloon help. It assumes boolean preference for backward compatibility"

	self addBooleanPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString.! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:02'!
addTextPreference: prefSymbol categories: categoryList default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: categoryList  default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofTextPreferences ! !

!Preferences class methodsFor: 'add preferences' stamp: 'hpt 9/26/2004 16:02'!
addTextPreference: prefSymbol category: categorySymbol default: defaultValue balloonHelp: helpString 
	"Add an item repreesenting the given preference symbol to the system. Default view for this preference is boolean to keep backward compatibility"

	self addPreference: prefSymbol  categories: {categorySymbol} default:  defaultValue balloonHelp: helpString  projectLocal: false  changeInformee: nil changeSelector: nil viewRegistry: PreferenceViewRegistry ofTextPreferences ! !

!Preferences class methodsFor: 'preference-object access' stamp: 'rr 10/1/2005 15:14'!
allPreferenceObjects
	"Answer a list of all the Preference objects registered in the system"

	^ self dictionaryOfPreferences values! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 11:45'!
allowBlockArgumentAssignment

	^ Parser allowBlockArgumentAssignment
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:06'!
allowBlockArgumentAssignmentSetting

	^ Parser allowBlockArgumentAssignment
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:06'!
allowBlockArgumentAssignmentSetting: aBoolean

	Parser allowBlockArgumentAssignment: aBoolean
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 11:45'!
allowUnderscoreAssignment
	^ Scanner allowUnderscoreAsAssignment
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:59'!
allowUnderscoreAssignmentSetting
	^ Scanner allowUnderscoreAsAssignment
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:07'!
allowUnderscoreAssignmentSetting: aBoolean
	Scanner allowUnderscoreAsAssignment: aBoolean
! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
allwaysShowVScrollBar
	^ self
		valueOfFlag: #allwaysShowVScrollBar
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
alternateHandlesLook
	^ self
		valueOfFlag: #alternateHandlesLook
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/14/2009 21:29'!
alternativeBrowseIt
	^ false! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
alternativeButtonsInScrollBars
	^ self
		valueOfFlag: #alternativeButtonsInScrollBars
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/17/2009 21:40'!
alwaysHideHScrollbar
	^ ScrollPane alwaysHideHScrollbar! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
alwaysShowConnectionVocabulary
	^ self
		valueOfFlag: #alwaysShowConnectionVocabulary
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/17/2009 21:40'!
alwaysShowHScrollbar
	^ ScrollPane alwaysShowHScrollbar! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/17/2009 21:41'!
alwaysShowVScrollbar
	^ ScrollPane alwaysShowVScrollbar! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 7/12/2001 18:18'!
annotationInfo 
	"Answer a list of pairs characterizing all the available kinds of annotations; in each pair, the first element is a symbol representing the info type, and the second element is a string providing the corresponding balloon help"

	^ #(

		(timeStamp			'The time stamp of the last submission of the method.')
		(firstComment		'The first comment in the method, if any.')
		(masterComment		'The comment at the beginning of the supermost implementor of the method if any.')
		(documentation		'Comment at beginning of the method or, if it has none, comment at the beginning of a superclass''s implementation of the method')
		(messageCategory	'Which method category the method lies in')
		(sendersCount		'A report of how many senders there of the message.')
		(implementorsCount	'A report of how many implementors there are of the message.')
		(recentChangeSet	'The most recent change set bearing the method.')
		(allChangeSets		'A list of all change sets bearing the method.')
		(priorVersionsCount	'A report of how many previous versions there are of the method' )
		(priorTimeStamp		'The time stamp of the penultimate submission of the method, if any'))! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 13:13'!
annotationPanes
	^ CodeHolder showAnnotationPane! !

!Preferences class methodsFor: 'reacting to change' stamp: 'AlainPlantec 10/17/2009 18:14'!
annotationPanesChanged
	"The setting of the annotationPanes preference changed; react"! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:00'!
annotationPanesSetting
	^ CodeHolder showAnnotationPane! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:41'!
annotationPanesSetting: aBoolean
	
	CodeHolder showAnnotationPane: aBoolean.
	MCCodeTool showAnnotationPane: aBoolean.! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 07:34'!
areaFillsAreTolerant
	^ self areaFillsAreTolerantSetting! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:34'!
areaFillsAreTolerantSetting
	^ Form floodFillTolerance > 0.0! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:34'!
areaFillsAreTolerantSetting: aBoolean 
	Form
		floodFillTolerance: (aBoolean
				ifTrue: [0.1]
				ifFalse: [0.0])! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 07:36'!
areaFillsAreVeryTolerant
	^ self areaFillsAreVeryTolerantSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:35'!
areaFillsAreVeryTolerantSetting
	^ Form floodFillTolerance > 0.1! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 07:35'!
areaFillsAreVeryTolerantSetting: aBoolean 
	Form
		floodFillTolerance: (aBoolean
				ifTrue: [0.2]
				ifFalse: [0.1])! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
autoFocusForColumns
	^ self
		valueOfFlag: #autoFocusForColumns
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
autoIndent
	^ self
		valueOfFlag: #autoIndent
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
automaticKeyGeneration
	^ self
		valueOfFlag: #automaticKeyGeneration
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
automaticPlatformSettings
	^ self
		valueOfFlag: #automaticPlatformSettings
		ifAbsent: [true]! !

!Preferences class methodsFor: 'misc' stamp: 'AlainPlantec 1/7/2010 23:39'!
balloonHelpDelayTime
	"Answer the number of milliseconds before a balloon help 
	should be put up on morphs."
	^ self parameters
		at: #balloonHelpDelayTime
		ifAbsent: [800]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 10:23'!
balloonHelpEnabled
	^ self balloonHelpEnabledSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/21/2009 12:12'!
balloonHelpEnabledSetting
	^ UITheme currentSettings balloonHelpEnabled! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/19/2009 23:21'!
balloonHelpEnabledSetting: aBoolean
	^ UITheme currentSettings balloonHelpEnabled: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
beDynamic
	^ self
		valueOfFlag: #beDynamic
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
bigDisplay
	^ self
		valueOfFlag: #bigDisplay
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
biggerHandles
	^ self
		valueOfFlag: #biggerHandles
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:04'!
browseWithPrettyPrint
	^ CodeHolder browseWithPrettyPrint 
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:00'!
browseWithPrettyPrintSetting
	^ CodeHolder browseWithPrettyPrint
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:42'!
browseWithPrettyPrintSetting: aBoolean
	CodeHolder browseWithPrettyPrint: aBoolean
! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
browserWindowColor
	^ self
		valueOfFlag: #browserWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 1.0
				b: 0.6]! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:39'!
caretWidth
	^ self parameters at: #caretWidth! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:39'!
caretWidth: anInteger
	^ self parameters at: #caretWidth put: anInteger! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 23:05'!
caseSensitiveFinds
	^ self caseSensitiveFindsSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 22:57'!
caseSensitiveFindsSetting
	^ ParagraphEditor caseSensitiveFinds! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 22:58'!
caseSensitiveFindsSetting: aBoolean
	ParagraphEditor caseSensitiveFinds: aBoolean! !

!Preferences class methodsFor: 'factored pref panel' stamp: 'sw 4/10/2001 14:29'!
categoriesContainingPreference: prefSymbol
	"Return a list of all categories in which the preference occurs"

	^ (self preferenceAt: prefSymbol ifAbsent: [^ #(unclassified)]) categoryList! !

!Preferences class methodsFor: 'preferences panel' stamp: 'rr 10/1/2005 15:14'!
categoryNames
	| aSet |
	aSet := Set new.
	self dictionaryOfPreferences  do:
			[:aPreference | 
			aSet  addAll:(aPreference categoryList 
						 collect:[:aCategory | aCategory asSymbol])].
	^ aSet! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
cautionBeforeClosing
	^ self
		valueOfFlag: #cautionBeforeClosing
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
changeListWindowColor
	^ self
		valueOfFlag: #changeListWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
changeSorterWindowColor
	^ self
		valueOfFlag: #changeSorterWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
chasingBrowsers
	^ self
		valueOfFlag: #chasingBrowsers
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 10:58'!
checkForSlips
	^ ChangeSet mustCheckForSlips! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:18'!
checkForSlipsSetting
	^ ChangeSet mustCheckForSlips! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:18'!
checkForSlipsSetting: aBoolean
	ChangeSet mustCheckForSlips: aBoolean! !

!Preferences class methodsFor: 'window colors' stamp: 'AlainPlantec 12/16/2009 21:25'!
checkForWindowColors
	self deprecated: 'Not used anymore since Settings integration'! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 15:15'!
chooseBalloonHelpFont
	BalloonMorph chooseBalloonFont! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:14'!
chooseCodeFont
	"Not currently sent, but once protocols are sorted out so that we can disriminate on whether a text object being launched is for code or not, will be reincorporated"

	self 
		chooseFontWithPrompt: 'Code font...' translated 
		andSendTo: StandardFonts 
		withSelector: #codeFont: 
		highlightSelector: #codeFont.! !

!Preferences class methodsFor: 'fonts' stamp: 'laza 3/25/2004 23:11'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector
	self chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: nil
! !

!Preferences class methodsFor: 'fonts' stamp: 'alain.plantec 5/30/2008 14:18'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont
	TextStyle promptForFont: aPrompt andSendTo: aReceiver withSelector: aSelector highlight: currentFont! !

!Preferences class methodsFor: 'FreeType-addition' stamp: 'marcus.denker 11/27/2008 16:16'!
chooseFontWithPrompt: aPrompt andSendTo: aReceiver withSelector: aSelector highlightSelector: highlightSelector

	FontChooser openWithWindowTitle: aPrompt 
				for: aReceiver 
				setSelector: aSelector
				getSelector: highlightSelector
	! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:16'!
chooseHaloLabelFont
	"present a menu with the possible fonts for label in halo"
	self
		chooseFontWithPrompt: 'Halo Label font...'
		andSendTo: StandardFonts
		withSelector: #haloFont:
		highlightSelector: #haloFont! !

!Preferences class methodsFor: 'initialization' stamp: 'StephaneDucasse 11/6/2009 20:03'!
chooseInitialSettings
	"Restore the default choices for all of the standard Preferences."

	self allPreferenceObjects do:
		[:aPreference |
			aPreference restoreDefaultValue].
	! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:17'!
chooseListFont
	self 
		chooseFontWithPrompt: 'List font...' translated
		andSendTo: StandardFonts 
		withSelector: #listFont: 
		highlightSelector: #listFont! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:18'!
chooseMenuFont
	self 
		chooseFontWithPrompt: 'Menu font...' translated
		andSendTo: StandardFonts 
		withSelector: #menuFont: 
		highlightSelector: #menuFont! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:18'!
chooseStandardButtonFont
	self 
		chooseFontWithPrompt: 'Button font...' translated
		andSendTo: StandardFonts 
		withSelector: #buttonFont: 
		highlightSelector: #buttonFont

! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:19'!
chooseSystemFont
	self 
		chooseFontWithPrompt: 'Default font...' translated
		andSendTo: StandardFonts 
		withSelector: #defaultFont:
		highlightSelector: #defaultFont! !

!Preferences class methodsFor: 'FreeType-override' stamp: 'AlainPlantec 12/6/2009 15:19'!
chooseWindowTitleFont
	self 
		chooseFontWithPrompt: 'Window Title font...' translated
		andSendTo: StandardFonts 
		withSelector: #windowTitleFont: 
		highlightSelector: #windowTitleFont! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
classCommentOnClassSelect
	^ self
		valueOfFlag: #classCommentOnClassSelect
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
classCommentVersionsBrowserWindowColor
	^ self
		valueOfFlag: #classCommentVersionsBrowserWindowColor
		ifAbsent: [Color
				r: 0.769
				g: 0.653
				b: 1.0]! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 10/19/2009 18:41'!
classicHaloSpecs
	"Non-iconic halos with traditional placements"

	"Preferences installClassicHaloSpecs"
	"Preferences resetHaloSpecifications"  "  <-  will result in the standard default halos being reinstalled"
	"NB: listed below in clockwise order"

		^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addMenuHandle:		left			top				(red)							none)
	(addDismissHandle:		leftCenter	top				(red		muchLighter)			#haloDismissIcon)
	(addGrabHandle:			center		top				(black)							none)
	(addDragHandle:			rightCenter	top				(brown)							none)
	(addDupHandle:			right		top				(green)							none)	
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		none)
	(addRepaintHandle:		right		center			(lightGray)						none)
	(addGrowHandle:		right		bottom			(yellow)						none)
	(addScaleHandle:		right		bottom			(lightOrange)					none)
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				none)
	(addFontStyleHandle:		center		bottom			(lightRed)						none)
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						none)

	(addRecolorHandle:		right		bottomCenter	(magenta darker)				none)

	(addRotateHandle:		left			bottom			(blue)							none))

! !

!Preferences class methodsFor: 'halos' stamp: 'hpt 9/24/2004 23:34'!
classicHalosInForce
	^ (self preferenceAt: #haloTheme) preferenceValue == #classicHaloSpecs! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 11:46'!
cmdDotEnabled
	^UserInterruptHandler cmdDotEnabled
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:08'!
cmdDotEnabledSetting
	^UserInterruptHandler cmdDotEnabled
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:08'!
cmdDotEnabledSetting: aBoolean
	UserInterruptHandler cmdDotEnabled: aBoolean
! !

!Preferences class methodsFor: 'standard queries' stamp: 'programmatic 7/15/1999 09:55'!
cmdGesturesEnabled
	"compiled programatically -- return hard-coded preference value"
	^ true! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'programmatic 7/15/1999 09:55'!
cmdKeysInText
	"compiled programatically -- return hard-coded preference value"
	^ true! !

!Preferences class methodsFor: 'initialization' stamp: 'NS 1/28/2004 14:43'!
compileAccessMethodForPreference: aPreference
	"Compile an accessor method for the given preference"

	self class compileSilently: (aPreference name, '
	^ self valueOfFlag: #', aPreference name, ' ifAbsent: [', aPreference defaultValue storeString, ']') classified: 'standard queries'! !

!Preferences class methodsFor: 'personalization' stamp: 'NS 1/28/2004 14:43'!
compileHardCodedPref: prefName enable: aBoolean
	"Compile a method that returns a simple true or false (depending on the value of aBoolean) when Preferences is sent prefName as a message"

	self class compileSilently: (prefName asString, '
	"compiled programatically -- return hard-coded preference value"
	^ ', aBoolean storeString) classified: 'hard-coded prefs'.
	
"Preferences compileHardCodedPref: #testing enable: false"! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
conversionMethodsAtFileOut
	^ self
		valueOfFlag: #conversionMethodsAtFileOut
		ifAbsent: [false
			"Form literalScannedAs: 14 notifying: nil 14
			Form literalScannedAs: #OneBitForm notiEfying: nil OneBitForm
			Form literalScannedAs: ##OneBitForm notifying: nil
			OneBitForm->a Form
			Form literalScannedAs: ##Form notifying: nil Form->Form
			Form literalScannedAs: ###Form notifying: nil nilE->Form clas
			"]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 11:46'!
cpuWatcherEnabled
	^ CPUWatcher cpuWatcherEnabled
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:08'!
cpuWatcherEnabledSetting
	^ CPUWatcher cpuWatcherEnabled
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:08'!
cpuWatcherEnabledSetting: aBoolean
	CPUWatcher cpuWatcherEnabled: aBoolean
! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 10/19/2009 18:40'!
customHaloSpecs
	"Intended for you to modify to suit your personal preference.  What is implemented in the default here is just a skeleton; in comment at the bottom of this method are some useful lines you may wish to paste in to the main body here, possibly modifying positions, colors, etc..
	Note that in this example, we include:
			Dismiss handle, at top-left
			Menu handle, at top-right
			Resize handle, at bottom-right
			Rotate handle, at bottom-left
			Drag handle, at top-center
			Recolor handle, at left-center.  (this one is NOT part of the standard formulary --
											it is included here to illustrate how to
 											add non-standard halos)
			Note that the optional handles for specialized morphs, such as Sketch, Text, PasteUp, are also included"

	^ #(
	(addDismissHandle:		left			top				(red		muchLighter)			#haloDismissIcon)
	(addMenuHandle:		right		top				(red)							#haloMenuIcon)
	(addDragHandle:			center	top					(brown)							#haloDragIcon)
	(addGrowHandle:		right		bottom			(yellow)						#haloScaleIcon)
	(addScaleHandle:		right		bottom			(lightOrange)					#haloScaleIcon)

	(addRecolorHandle:		left			center			(green muchLighter lighter)		#haloRecolorIcon)

	(addRepaintHandle:		right		center			(lightGray)						#haloPaintIcon)
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						#haloFontSizeIcon)
	(addFontStyleHandle:		center		bottom			(lightRed)						#haloFontStyleIcon)
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				#haloFontEmphIcon)
	(addRotateHandle:		left			bottom			(blue)							#haloRotIcon)

	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		#haloDebugIcon)
			)

	"  Other useful handles...

  		selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------

	(addTileHandle:			left			bottomCenter	(lightBrown)					#haloTileIcon)
	(addViewHandle:			left			center			(cyan)							#haloViewIcon)
	(addGrabHandle:			center		top				(black)							#haloGrabIcon)
	(addDragHandle:			rightCenter	top				(brown)							#haloDragIcon)
	(addDupHandle:			right		top				(green)							#haloDupIcon)	
	(addHelpHandle:			center		bottom			(lightBlue)						#haloHelpIcon)
	(addFewerHandlesHandle:	left		topCenter		(paleBuff)						#haloFewerHandlesIcon)
	(addPaintBgdHandle:		right		center			(lightGray)						#haloPaintIcon)
	(addRepaintHandle:		right		center			(lightGray)						#haloPaintIcon)
	"
! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 1/7/2010 22:13'!
customHalosInForce
	^ (self preferenceAt: #haloTheme) preferenceValue == #customHaloSpecifications! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 21:16'!
debugHaloHandle
	^ HaloMorph haloWithDebugHandle! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/8/2009 11:09'!
debugHaloHandleSetting
	^ HaloMorph haloWithDebugHandle! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/8/2009 11:09'!
debugHaloHandleSetting: aBoolean
	HaloMorph haloWithDebugHandle: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/18/2009 17:04'!
debugLogTimestamp
	^ Debugger debugLogTimestamp! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 21:21'!
debugPrintSpaceLog
	^ ImageSegment debugPrintSpaceLog! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:09'!
debugPrintSpaceLogSetting
	^ ImageSegment debugPrintSpaceLog! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:10'!
debugPrintSpaceLogSetting: aBoolean
	ImageSegment debugPrintSpaceLog: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 21:43'!
debugShowDamage
	^ WorldState debugShowDamage
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:10'!
debugShowDamageSetting
	^ WorldState debugShowDamage
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:10'!
debugShowDamageSetting: aBoolean
	 WorldState debugShowDamage: aBoolean
! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
debuggerWindowColor
	^ self
		valueOfFlag: #debuggerWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 0.8
				b: 0.8]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/8/2009 10:43'!
decorateBrowserButtons
	^ CodeHolder decorateBrowserButtons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:01'!
decorateBrowserButtonsSetting
	^ CodeHolder decorateBrowserButtons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:44'!
decorateBrowserButtonsSetting: aBoolean
	CodeHolder decorateBrowserButtons: aBoolean! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:40'!
defaultAnnotationRequests
	^ self parameters at: #MethodAnnotations ifAbsent:
		[self setDefaultAnnotationInfo]
	"Preferences annotationInfo"! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:40'!
defaultAnnotationRequests: newList
	^ self parameters at: #MethodAnnotations put: newList! !

!Preferences class methodsFor: 'parameters' stamp: 'on 5/10/2008 15:10'!
defaultAuthorName
	"Answer the author name to be planted, by default, in a changeset-preamble template.  You can hard-code this to hold your name, thus saving you time when writing the preambles of subsequent changesets"

	^ Author fullName! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 2/1/2000 14:05'!
defaultPaintingExtent
	"Answer the preferred size for the onion-skin paint area when launching a new painting within a paste-up morph.  Feel free to change the parameters to suit your configuration."

	^ 800 @ 600! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
defaultWindowColor
	^ self
		valueOfFlag: #defaultWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 12/7/2009 15:04'!
defaultWorldColor
	^ PasteUpMorph  defaultWorldColor ! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/10/2010 07:42'!
desktopColor
	^ PolymorphSystemSettings desktopColor 
! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/10/2010 07:42'!
desktopColor: aColor
	"Record a new desktop color preference."
	PolymorphSystemSettings desktopColor: aColor.
! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'sw 9/6/2000 05:26'!
desktopMenuTitle
	"Answer the title to be used for the 'meta menu'.  For now, you can hard-code this, later someone should make this be a parameter the user can easily change.  sw 9/6/2000"

	^ 'World'    "This is what it has always been"

	"^ 'Desktop'
	^ 'Squeak'
	^ 'Mike''s Control Panel'"! !

!Preferences class methodsFor: 'accessing' stamp: 'AlainPlantec 1/7/2010 23:26'!
dictionaryOfPreferences
	^DictionaryOfPreferences ifNil: [DictionaryOfPreferences := IdentityDictionary new]! !

!Preferences class methodsFor: 'accessing' stamp: 'rr 10/1/2005 15:14'!
dictionaryOfPreferences: anObject
	DictionaryOfPreferences := anObject! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/8/2009 10:45'!
diffsInChangeList
	^ CodeHolder diffsInChangeList! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:01'!
diffsInChangeListSetting
	^ CodeHolder diffsInChangeList! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:45'!
diffsInChangeListSetting: aBoolean
	^ CodeHolder diffsInChangeList: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/8/2009 10:45'!
diffsWithPrettyPrint
	^ CodeHolder diffsWithPrettyPrint! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:01'!
diffsWithPrettyPrintSetting
	^ CodeHolder diffsWithPrettyPrint! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:46'!
diffsWithPrettyPrintSetting: aBoolean
	CodeHolder diffsWithPrettyPrint: aBoolean! !

!Preferences class methodsFor: 'get/set' stamp: 'AlainPlantec 12/8/2009 10:19'!
disable: aSymbol
	"Shorthand access to enabling a preference of the given name.  If there is none in the image, conjure one up"

	| aPreference |
	aPreference := self preferenceAt: aSymbol ifAbsent:
		[self addPreference: aSymbol category: 'unclassified' default: false balloonHelp: 'this preference was added idiosyncratically and has no help message.'.
		self preferenceAt: aSymbol].
	aPreference preferenceValue: false! !

!Preferences class methodsFor: 'Polymorph-Widgets-Override' stamp: 'AlainPlantec 12/5/2009 18:57'!
disableProgrammerFacilities
	"Warning: do not call this lightly!!  It disables all access to menus, debuggers, halos.  There is no guaranteed return from this, which is to say, you cannot necessarily reenable these things once they are disabled -- you can only use whatever the UI of the current project affords, and you cannot even snapshot -- you can only quit. 

     You can completely reverse the work of this method by calling the dual Preferences method enableProgrammerFacilities, provided you have left yourself leeway to bring about a call to that method.
(does not reverse the ToolSet registrations)

	To set up a system that will come up in such a state, you have to request the snapshot in the same breath as you disable the programmer facilities.  To do this, put the following line into the 'do' menu and then evaluate it from that 'do' menu:

         Preferences disableProgrammerFacilities.

You will be prompted for a new image name under which to save the resulting image."
	self deprecated: 'No replacement for now'.

	Beeper beep.
	(self 
		confirm: 'CAUTION!!!!
This is a drastic step!!
Do you really want to do this?') 
			ifFalse: 
				[Beeper beep.
				^self inform: 'whew!!'].
	self disable: #cmdDotEnabled.	"No user-interrupt-into-debugger"
	self disable: #editableStringMorphs. "turn off shift-click editing"
	ToolSet registeredClasses copy do: [:c | ToolSet unregister: c].
	ToolSet default: nil. "unregister and make sure default is nil to really prevent debug windows"
		"also now takes care of low space watcher interrupts"
	self compileHardCodedPref: #cmdGesturesEnabled enable: false.	"No halos, etc."
	self compileHardCodedPref: #cmdKeysInText enable: false.	"No user commands invokable via cmd-key combos in text editor"
	self enable: #noviceMode.	"No control-menu"
	self disable: #warnIfNoSourcesFile.
	self disable: #warnIfNoChangesFile.
	SmalltalkImage current saveAs! !

!Preferences class methodsFor: 'Polymorph-Widgets' stamp: 'AlainPlantec 12/5/2009 18:57'!
disableProgrammerFacilitiesWithoutWarning
	"Warning: do not call this lightly!!  It disables all access to menus, debuggers, halos.  There is no guaranteed return from this, which is to say, you cannot necessarily reenable these things once they are disabled -- you can only use whatever the UI of the current project affords, and you cannot even snapshot -- you can only quit."
	self deprecated: 'No replacement for now'.

	self disable: #cmdDotEnabled.	"No user-interrupt-into-debugger"
	self disable: #editableStringMorphs. "turn off shift-click editing"
	ToolSet registeredClasses copy do: [:c | ToolSet unregister: c].
	ToolSet default: nil. "unregister and make sure default is nil to really prevent debug windows"
		"also now takes care of low space watcher interrupts"
	self compileHardCodedPref: #cmdGesturesEnabled enable: false.	"No halos, etc."
	self compileHardCodedPref: #cmdKeysInText enable: false.	"No user commands invokable via cmd-key combos in text editor"
	self enable: #noviceMode.	"No control-menu"
	self disable: #warnIfNoSourcesFile.
	self disable: #warnIfNoChangesFile! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
dismissAllOnOptionClose
	^ self
		valueOfFlag: #dismissAllOnOptionClose
		ifAbsent: [false]! !

!Preferences class methodsFor: 'get/set' stamp: 'sw 11/11/1998 11:40'!
doesNotUnderstand: aMessage
	"Look up the message selector as a flag."
	aMessage arguments size > 0 ifTrue: [^ super doesNotUnderstand: aMessage].
	^ self valueOfFlag: aMessage selector
! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
dualChangeSorterWindowColor
	^ self
		valueOfFlag: #dualChangeSorterWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 10:00'!
duplicateAllControlAndAltKeys
	^ self duplicateAllControlAndAltKeysSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 09:57'!
duplicateAllControlAndAltKeysSetting
	^ InputEventSensor controlAltKeyDecodePolicy = #FullMatching! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 10:05'!
duplicateAllControlAndAltKeysSetting: aBoolean
	aBoolean ifTrue: [InputEventSensor controlAltKeyDecodePolicy: #FullMatching]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 10:00'!
duplicateControlAndAltKeys
	^ self duplicateControlAndAltKeysSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 09:58'!
duplicateControlAndAltKeysSetting
	^ InputEventSensor controlAltKeyDecodePolicy = #PartialMatching
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 10:05'!
duplicateControlAndAltKeysSetting: aBoolean
	aBoolean ifTrue: [InputEventSensor controlAltKeyDecodePolicy: #PartialMatching]
! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
dynamicProtocolActivation
	^ self
		valueOfFlag: #dynamicProtocolActivation
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 08:16'!
easySelection
	^ self easySelectionSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 08:16'!
easySelectionSetting
	^ WorldState easySelectingWorld! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 08:16'!
easySelectionSetting: aBoolean 
	WorldState easySelectingWorld: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
ecompletionCaseSensitive
	^ self
		valueOfFlag: #ecompletionCaseSensitive
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
ecompletionEnabled
	^ self
		valueOfFlag: #ecompletionEnabled
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
ecompletionSmartCharacters
	^ self
		valueOfFlag: #ecompletionSmartCharacters
		ifAbsent: [true]! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 1/7/2010 22:13'!
editCustomHalos

	ToolSet browse: Preferences class
		selector: #customHaloSpecifications! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 11:51'!
editableStringMorphs
	^ self editableStringMorphsSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 11:50'!
editableStringMorphsSetting
	^ StringMorph editableStringMorph! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 11:51'!
editableStringMorphsSetting: aBoolean
	StringMorph editableStringMorph: aBoolean! !

!Preferences class methodsFor: 'get/set' stamp: 'AlainPlantec 12/8/2009 10:17'!
enable: aSymbol
	"Shorthand access to enabling a preference of the given name.  If there is none in the image, conjure one up"

	| aPreference |
	aPreference := self preferenceAt: aSymbol ifAbsent:
		[self addPreference: aSymbol category: 'unclassified' default: true balloonHelp: 'this preference was added idiosyncratically and has no help message.'.
		self preferenceAt: aSymbol].
	aPreference preferenceValue: true! !

!Preferences class methodsFor: 'Polymorph-Widgets-Override' stamp: 'AlainPlantec 12/5/2009 18:56'!
enableProgrammerFacilities
	"Meant as a one-touch recovery from a #disableProgrammerFacilities call."
	"Preferences enableProgrammerFacilities"
	self deprecated: 'No replacement for now'.
	self enable: #editableStringMorphs.
	self enable: #cmdDotEnabled.
	self compileHardCodedPref: #cmdGesturesEnabled enable: true. 
	self compileHardCodedPref: #cmdKeysInText enable: true.
	self disable: #noviceMode.
	self enable: #warnIfNoSourcesFile.
	self enable: #warnIfNoChangesFile.
	ToolSet default: StandardToolSet ! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
externalFocusForPluggableText
	^ self
		valueOfFlag: #externalFocusForPluggableText
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 08:17'!
externalFocusForPluggableTextSetting
	^ TextMorph externalFocusIndication! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 08:17'!
externalFocusForPluggableTextSetting: aBoolean 
	TextMorph externalFocusIndication: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 21:50'!
extraDebuggerButtons
	^ Debugger extraDebuggerButtons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:10'!
extraDebuggerButtonsSetting
	^ Debugger extraDebuggerButtons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:10'!
extraDebuggerButtonsSetting: aBoolean
	Debugger extraDebuggerButtons: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
fadedBackgroundWindows
	^ self
		valueOfFlag: #fadedBackgroundWindows
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 14:31'!
fadedBackgroundWindowsSetting
	^ UITheme currentSettings fadedBackgroundWindows! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 14:31'!
fadedBackgroundWindowsSetting: aBoolean
	^ UITheme currentSettings fadedBackgroundWindows: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 21:37'!
fastDragWindowForMorphic
	^ self fastDragWindowForMorphicSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 21:37'!
fastDragWindowForMorphicSetting
	^ UITheme currentSettings fastDragging! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 21:37'!
fastDragWindowForMorphicSetting: aBoolean
	UITheme currentSettings fastDragging: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
fileContentsBrowserWindowColor
	^ self
		valueOfFlag: #fileContentsBrowserWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 0.8
				b: 0.5]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
fileListWindowColor
	^ self
		valueOfFlag: #fileListWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 0.8
				b: 1.0]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:54'!
fontConfigurationMenu
	| aMenu |

	aMenu := MenuMorph new defaultTarget: Preferences.
	aMenu addTitle: 'Standard System Fonts' translated.
	
	aMenu addStayUpIcons.
	
	aMenu add: 'default text font...' translated action: #chooseSystemFont.
	aMenu balloonTextForLastItem: 'Choose the default font to be used for code and  in workspaces, transcripts, etc.' translated.
	aMenu lastItem font: StandardFonts defaultFont.
	
	aMenu add: 'list font...' translated action: #chooseListFont.
	aMenu lastItem font: Preferences standardListFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in list panes' translated.
	
	aMenu add: 'halo label font...' translated action: #chooseHaloLabelFont.
	aMenu lastItem font: Preferences standardHaloLabelFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used on labels ih halo' translated.

	aMenu add: 'menu font...' translated action: #chooseMenuFont.
	aMenu lastItem font: Preferences standardMenuFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in menus' translated.
	
	aMenu add: 'window-title font...' translated action: #chooseWindowTitleFont.
	aMenu lastItem font: Preferences windowTitleFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in window titles.' translated.

	aMenu add: 'balloon-help font...' translated action: #chooseBalloonHelpFont.
	aMenu lastItem font: Preferences standardBalloonHelpFont.
	aMenu balloonTextForLastItem: 'choose the font to be used when presenting balloon help.' translated.
	
	aMenu add: 'code font...' translated action: #chooseCodeFont. 
	aMenu lastItem font: Preferences standardCodeFont. 
	aMenu balloonTextForLastItem: 'Choose the font to be used in code panes.' translated.

	aMenu add: 'button font...' translated action: #chooseStandardButtonFont.
	aMenu lastItem font: Preferences standardButtonFont.
	aMenu balloonTextForLastItem: 'Choose the font to be used in buttons.' translated.

	aMenu addLine.
	aMenu add: 'demo mode' translated action: #setDemoFonts.
	aMenu balloonTextForLastItem: 'Set Fonts usable for giving a presentation' translated.

	aMenu addLine.
	aMenu add: 'restore default font choices' translated action: #restoreDefaultFonts.
	aMenu balloonTextForLastItem: 'Use the standard system font defaults' translated.
	
	aMenu add: 'print default font choices' translated action: #printStandardSystemFonts.
	aMenu balloonTextForLastItem: 'Print the standard system font defaults to the Transcript' translated.

	^ aMenu! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 18:47'!
fullScreenLeavesDeskMargins
	^ self fullScreenLeavesDeskMarginsSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 18:46'!
fullScreenLeavesDeskMarginsSetting
	^ SystemWindow fullScreenMargin > 0! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 18:49'!
fullScreenLeavesDeskMarginsSetting: aBoolean 
	^ SystemWindow fullScreenMargin: (aBoolean	ifFalse: [0])! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 13:06'!
generalizedYellowButtonMenu
	^ self generalizedYellowButtonMenuSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 13:05'!
generalizedYellowButtonMenuSetting
	^ Morph defaultYellowButtonMenuEnabled! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 13:06'!
generalizedYellowButtonMenuSetting: aBoolean
	Morph defaultYellowButtonMenuEnabled: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
gradientButtonLook
	^ self
		valueOfFlag: #gradientButtonLook
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/13/2009 13:25'!
gradientButtonLookSetting
	^ UITheme currentSettings preferGradientFill ! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/13/2009 13:25'!
gradientButtonLookSetting: aBoolean 
	UITheme currentSettings preferGradientFill: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/13/2009 21:51'!
gradientMenu
	^ self  gradientMenuSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 13:12'!
gradientMenuSetting
	^ UITheme current settings preferGradientFill ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 21:52'!
gradientMenuSetting: aBoolean
	^ UITheme currentSettings preferGradientFill: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
gradientScrollBars
	^ self
		valueOfFlag: #gradientScrollBars
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
gradientScrollbarLook
	^ self
		valueOfFlag: #gradientScrollbarLook
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 23:10'!
haloEnclosesFullBounds
	^ self haloEnclosesFullBoundsSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 23:10'!
haloEnclosesFullBoundsSetting
	^ HaloMorph haloEnclosesFullBounds
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 23:10'!
haloEnclosesFullBoundsSetting: aBoolean
	HaloMorph haloEnclosesFullBounds: aBoolean
! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 1/7/2010 23:40'!
haloSpecifications
	"Answer a list of HaloSpecs that describe which halos are to be used, what they should look like, and where they should be situated"

	^ self parameters at: #HaloSpecs ifAbsent:
			[self installHaloTheme: #iconicHaloSpecifications.
			^ Parameters at: #HaloSpecs]

	"Preferences haloSpecifications"
	"Preferences resetHaloSpecifications"
! !

!Preferences class methodsFor: 'halos' stamp: 'michael.rueger 3/9/2009 18:46'!
haloSpecificationsForWorld
	| desired |
	"Answer a list of HaloSpecs that describe which halos are to be used on a world halo, what they should look like, and where they should be situated"
	"Preferences resetHaloSpecifications"

	desired := #(addDebugHandle: addMenuHandle:   addHelpHandle:  addRecolorHandle:).
	^ self haloSpecifications select:
		[:spec | desired includes: spec addHandleSelector]! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: ''!
haloTheme
	^ self
		valueOfFlag: #haloTheme
		ifAbsent: [#iconicHaloSpecifications]! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/12/2009 10:07'!
haloThemeSetting
	^ #iconicHaloSpecifications! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
haloTransitions
	^ self
		valueOfFlag: #haloTransitions
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
hierarchyBrowserIsRB
	^ self
		valueOfFlag: #hierarchyBrowserIsRB
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
higherPerformance
	^ self
		valueOfFlag: #higherPerformance
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
honorDesktopCmdKeys
	^ self
		valueOfFlag: #honorDesktopCmdKeys
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:06'!
httpProxyPort
	^ HTTPSocket httpProxyPort 
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:25'!
httpProxyPortSetting
	^ HTTPSocket httpProxyPort 
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:25'!
httpProxyPortSetting: aPort
	HTTPSocket httpProxyPort: aPort
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:06'!
httpProxyServer
	^ HTTPSocket httpProxyServer 
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:26'!
httpProxyServerSetting
	^ HTTPSocket httpProxyServer 
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:26'!
httpProxyServerSetting: aServerName
	HTTPSocket httpProxyServer: aServerName
! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 12/19/2009 10:58'!
iconicHaloSpecifications
	"Answer an array that characterizes the locations, colors, icons, and selectors of the halo handles that may be used in the iconic halo scheme"

	"Preferences resetHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addCollapseHandle:		left			topCenter		(tan)							#haloCollapseIcon)
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		#haloDebugIcon)
	(addDismissHandle:		left			top				(red		muchLighter)			#haloDismissIcon)
	(addRotateHandle:		left			bottom			(blue)							#haloRotIcon)
	(addMenuHandle:		leftCenter	top				(red)							#haloMenuIcon)
	(addGrabHandle:			center		top				(black)							#haloGrabIcon)
	(addDragHandle:			rightCenter	top				(brown)							#haloDragIcon)
	(addDupHandle:			right		top				(green)							#haloDupIcon)	
	(addHelpHandle:			center		bottom			(lightBlue)						#haloHelpIcon)
	(addGrowHandle:		right		bottom			(yellow)						#haloScaleIcon)
	(addScaleHandle:		right		bottom			(lightOrange)					#haloScaleIcon)
	(addRepaintHandle:		right		center			(lightGray)						#haloPaintIcon)
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						#haloFontSizeIcon)
	(addFontStyleHandle:		center		bottom			(lightRed)						#haloFontStyleIcon)
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)				#haloFontEmphIcon)
	(addRecolorHandle:		right		bottomCenter	(magenta darker)				#haloRecolorIcon) ) ! !

!Preferences class methodsFor: 'halos' stamp: 'hpt 9/24/2004 23:34'!
iconicHalosInForce
	^ (self preferenceAt: #haloTheme) preferenceValue == #iconicHaloSpecifications! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 08:46'!
infiniteUndo
	^ self infiniteUndoSetting! !

!Preferences class methodsFor: 'reacting to change' stamp: 'sw 4/12/2001 01:32'!
infiniteUndoChanged
	"The infiniteUndo preference changed; react"
	
	self infiniteUndo ifFalse:
		[CommandHistory resetAllHistory]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 08:44'!
infiniteUndoSetting
	^ CommandHistory infiniteUndo! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 08:46'!
infiniteUndoSetting: aBoolean
	CommandHistory infiniteUndo: aBoolean! !

!Preferences class methodsFor: 'initialization' stamp: 'rr 10/1/2005 15:14'!
initializeDictionaryOfPreferences
	"Initialize the DictionaryOfPreferences to be an empty IdentityDictionary"

	"Preferences initializeDictionaryOfPreferences"

	self  dictionaryOfPreferences:IdentityDictionary new! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 9/7/1999 12:45'!
initializeParameters
	"Preferences initializeParameters"
	Parameters := IdentityDictionary new.
	self restoreDefaultMenuParameters.
	Parameters at: #maxBalloonHelpLineLength put: 28.
	self initializeTextHighlightingParameters! !

!Preferences class methodsFor: 'text highlighting' stamp: 'lr 7/12/2006 09:42'!
initializeTextHighlightingParameters
	"Preferences initializeTextHighlightingParameters"

	self
		caretWidth: 2;
		insertionPointColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.8);
		textHighlightColor: (TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.2)! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:40'!
inlineServicesInMenu
	^ self inlineServicesInMenuSetting
! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:41'!
insertionPointColor
	^ self parameters at: #insertionPointColor! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:41'!
insertionPointColor: aColor
	self parameters at: #insertionPointColor put: aColor! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 1/7/2010 23:41'!
installHaloSpecsFromArray: anArray

	| aColor |
	^ self parameters at: #HaloSpecs put: 
		(anArray collect:
			[:quin |
				aColor := Color.
				quin fourth do: [:sel | aColor := aColor perform: sel].
				HaloSpec new 
					horizontalPlacement: quin second
					verticalPlacement: quin third 
					color: aColor
					iconSymbol: quin fifth
					addHandleSelector: quin first])! !

!Preferences class methodsFor: 'halos' stamp: 'hpt 9/24/2004 23:35'!
installHaloTheme: themeSymbol
	self installHaloSpecsFromArray: (self perform: themeSymbol).
	(self preferenceAt: #haloTheme) preferenceValue: themeSymbol.
	! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
instanceBrowserWindowColor
	^ self
		valueOfFlag: #instanceBrowserWindowColor
		ifAbsent: [Color
				r: 0.806
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 19:17'!
keepTasklistOpen
	^ self keepTasklistOpenSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 19:16'!
keepTasklistOpenSetting
	^ TasklistMorph keepOpen! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 19:16'!
keepTasklistOpenSetting: aBoolean
	^ TasklistMorph keepOpen: aBoolean! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:41'!
keyboardFocusColor
	"Answer the keyboard focus color, initializing it if necessary"

	^ self parameters at: #keyboardFocusColor ifAbsentPut: [Color lightGray]

"
Parameters removeKey: #keyboardFocusColor.
Preferences keyboardFocusColor
"! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
lexiconWindowColor
	^ self
		valueOfFlag: #lexiconWindowColor
		ifAbsent: [Color
				r: 0.878
				g: 1.0
				b: 0.878]! !

!Preferences class methodsFor: 'personalization' stamp: 'marcus.denker 11/10/2008 10:04'!
loadPreferencesFrom: aFileName
	| stream params dict desktopColor |
	stream := ReferenceStream fileNamed: aFileName.
	params := stream next.
	self assert: (params isKindOf: IdentityDictionary).
	params removeKey: #PersonalDictionaryOfPreferences.
	dict := stream next.
	self assert: (dict isKindOf: IdentityDictionary).
	desktopColor := stream next.
	stream close.
	dict keysAndValuesDo:
		[:key :value | (self preferenceAt: key ifAbsent: [nil]) ifNotNil:
			[:pref | pref preferenceValue: value preferenceValue]].

	params keysAndValuesDo: [ :key :value | self setParameter: key to: value ].

	World fillStyle: desktopColor ! !

!Preferences class methodsFor: 'initialization' stamp: 'AlainPlantec 12/19/2009 22:51'!
localeChanged
	LocaleID current isoLanguage = 'ja'
		ifTrue: [PaintBoxMorph useFormsInPaintBox: true]
		ifFalse: [PaintBoxMorph useFormsInPaintBox: false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 21:59'!
logDebuggerStackToFile
	^ Debugger logDebuggerStackToFile
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:11'!
logDebuggerStackToFileSetting
	^ Debugger logDebuggerStackToFile
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:11'!
logDebuggerStackToFileSetting: aBoolean
	Debugger logDebuggerStackToFile: aBoolean
! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
magicHalos
	^ self
		valueOfFlag: #magicHalos
		ifAbsent: [false
			"Form literalScannedAs: 14 notifying: nil 14
			Form literalScannedAs: #OneBitForm notiEfying: nil OneBitForm
			Form literalScannedAs: ##OneBitForm notifying: nil
			OneBitForm->a Form
			Form literalScannedAs: ##Form notifying: nil Form->Form
			Form literalScannedAs: ###Form notifying: nil nilE->Form clas
			"]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
maintainHalos
	^ self
		valueOfFlag: #maintainHalos
		ifAbsent: [true]! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:41'!
maxBalloonHelpLineLength
	^ self parameters at: #maxBalloonHelpLineLength! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 20:03'!
menuAppearance3d
	^ self menuAppearance3dSetting ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 20:00'!
menuAppearance3dSetting
	^ UITheme currentSettings flatMenu not! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 20:00'!
menuAppearance3dSetting: aBoolean
	^ UITheme currentSettings flatMenu: aBoolean not! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuBorderColor
	Display depth <= 2 ifTrue: [^ Color black].
	^ self parameters at: #menuBorderColor! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuBorderWidth
	^ self parameters at: #menuBorderWidth! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuColor
	Display depth <= 2 ifTrue: [^ Color white].
	^ self parameters at: #menuColor! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/13/2009 18:31'!
menuColorFromWorld
	^ self menuColorFromWorldSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 18:25'!
menuColorFromWorldSetting
	^ UITheme currentSettings autoMenuColor! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 18:24'!
menuColorFromWorldSetting: aBoolean
	UITheme currentSettings autoMenuColor: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/19/2009 23:23'!
menuKeyboardControl
	^ UITheme currentSettings menuKeyboardControl! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuLineColor
	^ self parameters
		at: #menuLineColor
		ifAbsentPut: [Preferences menuBorderColor lighter]! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 12/19/2009 14:07'!
menuSelectionColor
	^ UITheme currentSettings menuSelectionColor! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuTitleBorderColor
	Display depth <= 2 ifTrue: [^ Color black].
	^ self parameters at: #menuTitleBorderColor! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuTitleBorderWidth
	^ self parameters at: #menuTitleBorderWidth! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
menuTitleColor
	Display depth = 1 ifTrue: [^ Color white].
	Display depth = 2 ifTrue: [^ Color gray].
	^ self parameters at: #menuTitleColor! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/13/2009 15:27'!
menuWithIcons
	^ self menuWithIconsSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 15:26'!
menuWithIconsSetting
	^ UITheme currentSettings menuWithIcons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 15:26'!
menuWithIconsSetting: aBoolean
	^ UITheme currentSettings menuWithIcons: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
mercuryPanel
	^ self
		valueOfFlag: #mercuryPanel
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
messageListWindowColor
	^ self
		valueOfFlag: #messageListWindowColor
		ifAbsent: [Color
				r: 0.8
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
messageNamesWindowColor
	^ self
		valueOfFlag: #messageNamesWindowColor
		ifAbsent: [Color
				r: 0.645
				g: 1.0
				b: 0.452]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
methodFinderWindowColor
	^ self
		valueOfFlag: #methodFinderWindowColor
		ifAbsent: [Color
				r: 0.4
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
modalColorPickers
	^ self
		valueOfFlag: #modalColorPickers
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
mouseClickForKeyboardFocus
	^ self
		valueOfFlag: #mouseClickForKeyboardFocus
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 14:31'!
mouseClickForKeyboardFocusSetting
	^ MorphicModel keyboardFocusOnMouseDown! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 14:31'!
mouseClickForKeyboardFocusSetting: aBoolean
	MorphicModel keyboardFocusOnMouseDown: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 14:54'!
mouseOverForKeyboardFocus
	^ self mouseOverForKeyboardFocusSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 14:54'!
mouseOverForKeyboardFocusSetting
	^ MorphicModel mouseOverForKeyboardFocus! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 14:54'!
mouseOverForKeyboardFocusSetting: aBoolean
	MorphicModel mouseOverForKeyboardFocus: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
mouseOverHalos
	^ self
		valueOfFlag: #mouseOverHalos
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 09:33'!
multipleTextUndo
	^ self multipleTextUndoSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:33'!
multipleTextUndoSetting
	^ TextMorphEditor useMultipleUndo! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:34'!
multipleTextUndoSetting: aBoolean
	TextMorphEditor useMultipleUndo: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
noWindowAnimationForClosing
	^ self
		valueOfFlag: #noWindowAnimationForClosing
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:50'!
noWindowAnimationForClosingSetting
	^ UITheme currentAnimationSettings animateClosing not! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:50'!
noWindowAnimationForClosingSetting: aBoolean
	UITheme currentAnimationSettings animateClosing: aBoolean not! !

!Preferences class methodsFor: 'misc' stamp: 'sw 4/24/2001 12:02'!
okayToChangeProjectLocalnessOf: prefSymbol
	"Answer whether it would be okay to allow the user to switch the setting of whether or not the preference symbol is local to a project.  Formerly useful and perhaps again will be, though to be sure this is a non-modular design."

	^ (#() includes: prefSymbol) not! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 13:12'!
optionalButtons
	^ CodeHolder optionalButtons! !

!Preferences class methodsFor: 'reacting to change' stamp: 'AlainPlantec 10/17/2009 18:19'!
optionalButtonsChanged
	"The setting of the optionalButtons preference changed; react."
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:01'!
optionalButtonsSetting
	^ CodeHolder optionalButtons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:47'!
optionalButtonsSetting: aBoolean
	CodeHolder optionalButtons: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
packageBrowserWindowColor
	^ self
		valueOfFlag: #packageBrowserWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 1.0
				b: 0.6]! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
parameterAt: aKey
	^ self parameters at: aKey ifAbsent: [nil]! !

!Preferences class methodsFor: 'parameters' stamp: 'sw 9/28/2001 08:52'!
parameterAt: aKey default: defaultValueBlock
	"Deprecated interface; no surviving senders in the released image, but clients probably still use"

	^ self parameterAt: aKey ifAbsentPut: defaultValueBlock! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
parameterAt: aKey ifAbsent: aBlock
	"Answer the parameter saved at the given key; if there is no such key in the Parameters dictionary, evaluate aBlock"

	^ self parameters at: aKey ifAbsent: [aBlock value]! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:42'!
parameterAt: aKey ifAbsentPut: defaultValueBlock
	"Return the Parameter setting at the given key.  If there is no entry for this key in the Parameters dictionary, create one with the value of defaultValueBlock as its value"

	^ self parameters at: aKey ifAbsentPut: defaultValueBlock! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:41'!
parameters
	^ Parameters ifNil: [self initializeParameters. Parameters]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
postscriptStoredAsEPS
	^ self
		valueOfFlag: #postscriptStoredAsEPS
		ifAbsent: [false]! !

!Preferences class methodsFor: 'preference-object access' stamp: 'rr 10/1/2005 15:14'!
preferenceAt: aSymbol 
	"Answer the Preference object at the given symbol, or nil if not there"

	^ self dictionaryOfPreferences  at:aSymbol  ifAbsent:[nil]! !

!Preferences class methodsFor: 'preference-object access' stamp: 'rr 10/1/2005 15:14'!
preferenceAt: aSymbol ifAbsent: aBlock 
	"Answer the Preference object at the given symbol, or the value of aBlock if not present"

	^ self dictionaryOfPreferences  at:aSymbol  ifAbsent:[aBlock value]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
preferenceBrowserWindowColor
	^ self
		valueOfFlag: #preferenceBrowserWindowColor
		ifAbsent: [Color
				r: 0.645
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'preferences panel' stamp: 'rr 10/1/2005 15:14'!
preferenceObjectsInCategory: aCategorySymbol 
	"Answer a list of Preference objects that reside in the given category, in alphabetical order"

	^ (self dictionaryOfPreferences 
		 select:[:aPreference | aPreference categoryList  includes:aCategorySymbol]) 
			 asSortedCollection:
				[:pref1 :pref2 | 
				pref1 viewRegistry viewOrder  <pref2 viewRegistry viewOrder  or:
						[pref1 viewRegistry viewOrder  =pref2 viewRegistry viewOrder 
							 &(pref1 name  <pref2 name)]]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
preferencesPanelWindowColor
	^ self
		valueOfFlag: #preferencesPanelWindowColor
		ifAbsent: [Color
				r: 0.645
				g: 1.0
				b: 1.0]! !

!Preferences class methodsFor: 'hard-coded prefs' stamp: 'sw 8/29/2000 15:01'!
preserveCommandExcursions
	"An architecture is in place for storing command excursions to which access is otherwise cut off by having taken a variant branch, but it is not accessible unless you hand-code this preference to true -- which I suggest you do only with fingers crossed."

	^ false! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 15:19'!
preserveTrash
	^ self preserveTrashSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 07:22'!
preserveTrashNoSetting
	^ false! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:18'!
preserveTrashSetting
	^ false! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:18'!
preserveTrashSetting: aBoolean
! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 15:44'!
printStandardSystemFonts
	"self printStandardSystemFonts"

	| string |
	string := String streamContents: [ :s |

	StandardFonts systemFontAspects do: [:selector |
		| font |
		font := StandardFonts perform: selector.
		s
			nextPutAll: selector; space;
			nextPutAll: font familyName; space;
			nextPutAll: (AbstractFont emphasisStringFor: font emphasis);
			nextPutAll: ' points: ';
			print: font pointSize;
			nextPutAll: ' height: ';
			print: font height;
			cr
		]].

	(StringHolder new)
		contents: string;
		openLabel: 'Current system font settings' translated.
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:48'!
promptForUpdateServer
	^ self promptForUpdateServerSetting
	! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 22:47'!
promptForUpdateServerSetting
	^ Utilities promptForUpdateServer! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 22:47'!
promptForUpdateServerSetting: aBoolean
	Utilities promptForUpdateServer: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
promptOnRefactoring
	^ self
		valueOfFlag: #promptOnRefactoring
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 09:42'!
purgeUndoOnQuit
	^ self purgeUndoOnQuitSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:42'!
purgeUndoOnQuitSetting
	^ CommandHistory purgeUndoOnQuit! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:42'!
purgeUndoOnQuitSetting: aBoolean
	^ CommandHistory purgeUndoOnQuit: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 10:11'!
raiseDeprecatedWarnings
	^ self raiseDeprecatedWarningsSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 10:10'!
raiseDeprecatedWarningsSetting
	^ Deprecation raiseWarning! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 10:17'!
raiseDeprecatedWarningsSetting: aBoolean
	Deprecation raiseWarning: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: 'AlainPlantec 12/17/2009 21:45'!
readDocumentAtStartup
	^ self readDocumentAtStartupSetting! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:44'!
readDocumentAtStartupSetting
	^ ProjectLauncher readDocumentAtStartup! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:45'!
readDocumentAtStartupSetting: aBoolean
	ProjectLauncher readDocumentAtStartup: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
readOnlyMode
	^ self
		valueOfFlag: #readOnlyMode
		ifAbsent: [false]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 15:45'!
refreshFontSettings
	"Try to update all the current font settings to make things consistent."

	StandardFonts systemFontAspects  do: [:a |
		StandardFonts perform: (a,':') asSymbol with: (StandardFonts perform: a)].

	SystemWindow allSubInstancesDo: [ :s | | rawLabel |
		rawLabel := s getRawLabel.
		rawLabel owner vResizing: #spaceFill.
		rawLabel font: rawLabel font.
		s setLabel: s label.
		s replaceBoxes ].! !

!Preferences class methodsFor: 'initialization' stamp: 'ar 9/27/2005 21:49'!
removeObsolete
	"Remove obsolete preferences"
	Preference allInstancesDo:[:pref|
		pref isObsolete ifTrue:[self removePreference: pref].
	].! !

!Preferences class methodsFor: 'initialization' stamp: 'AlainPlantec 1/7/2010 23:43'!
removePreference: aSymbol
	"Remove all memory of the given preference symbol."
	
	self dictionaryOfPreferences removeKey: aSymbol ifAbsent: [].
	self parameters removeKey: aSymbol ifAbsent: [].
	(Parameters at: #PersonalDictionaryOfPreferences ifAbsent: []) 
		ifNotNil: [:personalDict | personalDict removeKey: aSymbol ifAbsent: []]! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 1/7/2010 23:43'!
resetHaloSpecifications
	"Preferences resetHaloSpecifications"

	^ self parameters removeKey: #HaloSpecs ifAbsent: []! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 22:08'!
restartAlsoProceeds
	^ Debugger restartAlsoProceeds! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:11'!
restartAlsoProceedsSetting
	^ Debugger restartAlsoProceeds! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:11'!
restartAlsoProceedsSetting: aBoolean
	Debugger restartAlsoProceeds: aBoolean! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/20/2009 00:44'!
restoreDefaultFonts
	"Since this is called from menus, we can take the opportunity to prompt for missing font styles."
	"
	Preferences restoreDefaultFonts
	"	
	StandardFonts setFontsFromSpec: 
		#( #(#defaultFont: 'Bitmap DejaVu Sans' 9 ) 
			#(#codeFont: 'Bitmap DejaVu Sans' 9 ) 
			#(#listFont: 'Bitmap DejaVu Sans' 9 ) 
			#(#menuFont: 'Bitmap DejaVu Sans' 9 ) 
			#(#windowTitleFont: 'Bitmap DejaVu Sans' 12 ) 
			#(#balloonFont: 'Accuny' 10 ) 
			#(#haloFont: 'Accuny' 10 ) 
			#(#buttonFont: 'Bitmap DejaVu Sans' 9 ) ).
! !

!Preferences class methodsFor: 'menu parameters' stamp: 'AlainPlantec 1/7/2010 23:43'!
restoreDefaultMenuParameters
	"Restore the four color choices of the original implementors of  
	MorphicMenus"
	" 
	Preferences restoreDefaultMenuParameters
	"
	self parameters
		at: #menuColor
		put: (Color
				r: 0.97
				g: 0.97
				b: 0.97).
	self parameters
		at: #menuBorderColor
		put: (Color
				r: 0.167
				g: 0.167
				b: 1.0).
	self parameters at: #menuBorderWidth put: 2.
	self parameters at: #menuTitleColor put: (Color
			r: 0.4
			g: 0.8
			b: 0.9) twiceDarker.
	self parameters
		at: #menuTitleBorderColor
		put: (Color
				r: 0.333
				g: 0.667
				b: 0.751).
	self parameters at: #menuTitleBorderWidth put: 1.
	self parameters
		at: #menuLineColor
		put: (Preferences menuBorderColor lighter)! !

!Preferences class methodsFor: 'personalization' stamp: 'marcus.denker 11/10/2008 10:04'!
restorePersonalPreferences
	"Restore all the user's saved personal preference settings"

	| savedPrefs |
	savedPrefs := self parameterAt: #PersonalDictionaryOfPreferences ifAbsent: [^ self inform: 'There are no personal preferences saved in this image yet'].

	savedPrefs associationsDo:
		[:assoc | (self preferenceAt: assoc key ifAbsent: [nil]) ifNotNil:
			[:pref | pref preferenceValue: assoc value preferenceValue]]! !

!Preferences class methodsFor: 'personalization' stamp: 'nk 11/17/2002 12:07'!
restorePreferencesFromDisk
	(FileDirectory default fileExists: 'my.prefs')
		ifTrue: [ Cursor wait showWhile: [
			[ self loadPreferencesFrom: 'my.prefs' ] on: Error do: [ :ex | self inform: 'there was an error restoring the preferences' ]
		] ]
		ifFalse: [ self inform: 'you haven''t saved your preferences yet!!' ].
	! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 19:41'!
reverseWindowStagger
	^ self reverseWindowStaggerSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/14/2009 19:40'!
reverseWindowStaggerSetting
	^ RealEstateAgent useReverseStaggerStragegy! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/14/2009 19:40'!
reverseWindowStaggerSetting: aBoolean
	RealEstateAgent useReverseStaggerStragegy: aBoolean! !

!Preferences class methodsFor: 'misc' stamp: 'AlainPlantec 12/20/2009 00:21'!
roundedCornersString
	^ (((self valueOfFlag: #roundedWindowCorners)
		ifTrue: ['stop']
		ifFalse: ['start']) , ' rounding window corners') translated! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/13/2009 15:42'!
roundedMenuCorners
	^ self roundedMenuCornersSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 15:40'!
roundedMenuCornersSetting
	^ UITheme currentSettings preferRoundCorner! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/13/2009 15:40'!
roundedMenuCornersSetting: aBoolean
	UITheme currentSettings preferRoundCorner: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 19:59'!
roundedWindowCorners
	^ self roundedWindowCornersSetting	! !

!Preferences class methodsFor: 'reacting to change' stamp: 'sw 4/12/2001 01:11'!
roundedWindowCornersChanged
	"The user changed the value of the roundedWindowCorners preference.  React"

	ActiveWorld fullRepaintNeeded! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 19:58'!
roundedWindowCornersSetting
	^ UITheme currentSettings preferRoundCorner ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 19:58'!
roundedWindowCornersSetting: aBoolean
	UITheme currentSettings preferRoundCorner: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
rulesAccessSelector
	^ self
		valueOfFlag: #rulesAccessSelector
		ifAbsent: ['defaultCategorizationRules']! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
rulesGlobalName
	^ self
		valueOfFlag: #rulesGlobalName
		ifAbsent: ['AutomaticMethodCategorizer']! !

!Preferences class methodsFor: 'personalization' stamp: 'rr 10/1/2005 15:14'!
savePersonalPreferences
	"Save the current list of Preference settings as the user's personal choices"

	self  setParameter:#PersonalDictionaryOfPreferences
		 to:self dictionaryOfPreferences deepCopy! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
scrollBarsNarrow
	^ self
		valueOfFlag: #scrollBarsNarrow
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
scrollBarsOnRight
	^ self
		valueOfFlag: #scrollBarsOnRight
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 14:44'!
scrollBarsOnRightSetting
	^ UITheme currentSettings scrollBarsOnRight! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
scrollBarsWithoutMenuButton
	^ self
		valueOfFlag: #scrollBarsWithoutMenuButton
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 21:26'!
securityChecksEnabled
	^ self securityChecksEnabledSetting! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:25'!
securityChecksEnabledSetting
	^ SecurityManager default securityChecksEnabled! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:25'!
securityChecksEnabledSetting: aBoolean
	SecurityManager default securityChecksEnabled: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
selectiveHalos
	^ self
		valueOfFlag: #selectiveHalos
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 14:07'!
serverMode
	^ self serverModeSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 14:05'!
serverModeSetting
	^ WorldState serverMode! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/14/2009 14:05'!
serverModeSetting: aBoolean
	WorldState serverMode: aBoolean! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:24'!
setBalloonHelpFontTo: aFont
	StandardFonts balloonFont: aFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:25'!
setButtonFontTo: aFont
	StandardFonts buttonFont: aFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:25'!
setCodeFontTo: aFont
	"Establish the code font."
	StandardFonts codeFont: aFont! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:43'!
setDefaultAnnotationInfo
	"Preferences setDefaultAnnotationInfo"
	^ self parameters at: #MethodAnnotations put: #(timeStamp messageCategory sendersCount implementorsCount allChangeSets)! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:25'!
setDefaultFonts: defaultFontsSpec
	"Since this is called from menus, we can take the opportunity to prompt for missing font styles."

	| fontNames map emphases |
	fontNames := defaultFontsSpec collect: [:array | array second].
	map := IdentityDictionary new.
	emphases := IdentityDictionary new.
	fontNames do: [:originalName | | decoded style response |
		decoded := TextStyle decodeStyleName: originalName.
		style := map at: originalName put: (TextStyle named: decoded second).
		emphases at: originalName put: decoded first.
		style ifNil: [map at: originalName put: (TextStyle default) ]].
	defaultFontsSpec do: [:triplet | self
		perform: triplet first
		with: (((map at: triplet second) fontOfPointSize: triplet third) emphasized: (emphases at: triplet second))]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:27'!
setDemoFonts
	"Preferences setDemoFonts"
	|size font codeFont titleFont|

	size := UIManager default request: 'Base font size?' initialAnswer: '14'.
	size isEmptyOrNil ifTrue: [^ self].
	size := size asInteger.
	(size isNil or: [size <= 0]) ifTrue: [^ self].
	font := LogicalFont familyName: 'DejaVu Sans' pointSize: size.
	codeFont := LogicalFont familyName: 'DejaVu Sans Mono' pointSize: size.
	titleFont := LogicalFont familyName: 'DejaVu Serif' pointSize: size.

	StandardFonts
		listFont: font;
		menuFont: font;
		codeFont: codeFont;
		buttonFont: font;
		defaultFont: font;
		windowTitleFont: titleFont.! !

!Preferences class methodsFor: 'misc' stamp: 'sw 1/4/2001 06:56'!
setFlag: prefSymbol toValue: aBoolean during: aBlock
	"Set the flag to the given value for the duration of aBlock"

	| existing |
	existing := self valueOfFlag: prefSymbol.
	existing == aBoolean ifFalse: [self setPreference: prefSymbol toValue: aBoolean].
	aBlock value.
	existing == aBoolean ifFalse: [self setPreference: prefSymbol toValue: existing]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:29'!
setHaloLabelFontTo: aFont 
	"change the font used in eToys environment"
	StandardFonts haloFont: aFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:29'!
setListFontTo: aFont
	"Set the list font as indicated"
	StandardFonts listFont: aFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:32'!
setMenuFontTo: aFont
	"rbb 2/18/2005 12:54 - How should this be changed to work
	with the UIManager, if at all?"
	StandardFonts menuFont: aFont.
! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 1/7/2010 23:43'!
setPaintBoxButtonFontTo: aFont 
	"change the font used in the buttons in PaintBox."
	self parameters at: #paintBoxButtonFont put: aFont! !

!Preferences class methodsFor: 'parameters' stamp: 'AlainPlantec 1/7/2010 23:43'!
setParameter: paramName to: paramValue
	"Set the given field in the parameters dictionary."

	self parameters at: paramName put: paramValue! !

!Preferences class methodsFor: 'get/set' stamp: 'sw 4/12/2001 23:29'!
setPreference: prefSymbol toValue: aBoolean
	"Set the given preference to the given value, and answer that value"

	^ (self preferenceAt: prefSymbol ifAbsent: [^ aBoolean]) preferenceValue: aBoolean! !

!Preferences class methodsFor: 'initialization' stamp: 'sw 4/21/2002 05:13'!
setPreferencesFrom: listOfPairs
	"Given a list of <preferenceName, value> pairs, set preference values.  This method is tolerent of the value being supplied either a Boolean or else one of the symbols #true and #false.  Also, a new-value of #noOpinion will result in that 'preference's value not being changed."

	listOfPairs do:
		[:aPair |
			(aPair second == #noOpinion) ifFalse:
				[Preferences setPreference: aPair first toValue: ((aPair second == #true) or: [aPair second == true])]]

"
Preferences setPreferencesFrom: #(( mouseOverForKeyboardFocus false))
Preferences setPreferencesFrom: {{  #mouseOverForKeyboardFocus. true}}
"! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:33'!
setSystemFontTo: aFont
	"Establish the default text font and style"

	StandardFonts defaultFont: aFont.
! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:34'!
setWindowTitleFontTo: aFont
	"Set the window-title font to be as indicated"
	StandardFonts windowTitleFont: aFont.
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 10:24'!
settingsMigrationCheck
	Preference allInstances do: [:p | p settingsMigrationCheck]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 23:19'!
showBoundsInHalo
	^ self showBoundsInHaloSetting
	! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 23:18'!
showBoundsInHaloSetting
	^ HaloMorph showBoundsInHalo! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 23:19'!
showBoundsInHaloSetting: aBoolean
	^ HaloMorph showBoundsInHalo: aBoolean! !

!Preferences class methodsFor: 'halos' stamp: 'sw 11/6/2000 10:02'!
showChooseGraphicHaloHandle
	"Hard-coded; reimplement to change behavior.  If this preference is set to true, then a choose-graphic halo handle may appear on the halo of SketchMorphs"

	^ false! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 10:16'!
showDeprecationWarnings
	^ self showDeprecationWarningsSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 10:16'!
showDeprecationWarningsSetting
	^ Deprecation showWarning! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 10:16'!
showDeprecationWarningsSetting: aBoolean
	Deprecation showWarning: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
showDirectionForSketches
	^ self
		valueOfFlag: #showDirectionForSketches
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
showDirectionHandles
	^ self
		valueOfFlag: #showDirectionHandles
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 21:27'!
showSecurityStatus
	^ self showSecurityStatusSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:26'!
showSecurityStatusSetting
	^ SecurityManager default showSecurityStatus! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:27'!
showSecurityStatusSetting: aBoolean
	SecurityManager default showSecurityStatus: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/14/2009 21:48'!
showSplitterHandles
	^ self showSplitterHandlesSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/14/2009 21:47'!
showSplitterHandlesSetting
	^ ProportionalSplitterMorph showSplitterHandles! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/14/2009 21:48'!
showSplitterHandlesSetting: aBoolean
	ProportionalSplitterMorph showSplitterHandles: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
showTextEditingState
	^ self
		valueOfFlag: #showTextEditingState
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:12'!
showTextEditingStateSetting
	^ PluggableTextEditorMorph showTextEditingState! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:13'!
showTextEditingStateSetting: aBoolean
	PluggableTextEditorMorph showTextEditingState: aBoolean! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:15'!
showWorldTaskbarSetting
	^ TaskbarMorph showTaskbar! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:15'!
showWorldTaskbarSetting: aBoolean
	TaskbarMorph showTaskbar: aBoolean! !

!Preferences class methodsFor: 'halos' stamp: 'AlainPlantec 12/12/2009 09:59'!
simpleFullHaloSpecifications
	"This method gives the specs for the 'full' handles variant when simple halos are in effect"

	"Preferences resetHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"
	(addDebugHandle:		right		topCenter		(blue	veryMuchLighter)		#haloDebugIcon)
	(addDismissHandle:		left			top				(red		muchLighter)			#haloDismissIcon)
	(addRotateHandle:		left			bottom			(blue)							#haloRotIcon)
	(addMenuHandle:		leftCenter	top				(red)							#haloMenuIcon)
	(addGrabHandle:			center		top				(black)							#halograbIcon)
	(addDragHandle:			rightCenter	top				(brown)							#haloDragIcon)
	(addDupHandle:			right		top				(green)							#haloDupIcon)	
	(addHelpHandle:			center		bottom			(lightBlue)						#haloHelpIcon')
	(addGrowHandle:		right		bottom			(yellow)						#haloScaleIcon)
	(addScaleHandle:		right		bottom			(lightOrange)					#haloScaleIcon)
	(addFewerHandlesHandle:	left		topCenter		(paleBuff)						#haloFewerHandlesIcon')
	(addRepaintHandle:		right		center			(lightGray)						#haloPaintIcon)
	(addFontSizeHandle:		leftCenter	bottom			(lightGreen)						#haloFontSizeIcon)
	(addFontStyleHandle:		center		bottom			(lightRed)						#haloFontStyleIcon)
	(addFontEmphHandle:	rightCenter	bottom			(lightBrown darker)		  		#haloFontEmphIcon)
	(addRecolorHandle:		right		bottomCenter	(magenta darker)				#haloRecolorIcon) ) ! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 15:20'!
slideDismissalsToTrash
	^ self slideDismissalsToTrashSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:18'!
slideDismissalsToTrashSetting
	^ false
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:18'!
slideDismissalsToTrashSetting: aBoolean
! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 15:21'!
smartUpdating
	^ self smartUpdatingSetting! !

!Preferences class methodsFor: 'reacting to change' stamp: 'sw 4/12/2001 01:30'!
smartUpdatingChanged
	"The smartUpdating preference changed. React"

	SystemWindow allSubInstancesDo:
		[:aWindow | aWindow amendSteppingStatus]

	"NOTE: This makes this preference always behave like a global preference, which is problematical"! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/10/2009 15:20'!
smartUpdatingSetting
	^ CodeHolder smartUpdating
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 10:48'!
smartUpdatingSetting: aBoolean
	CodeHolder smartUpdating: aBoolean
! !

!Preferences class methodsFor: 'misc' stamp: 'marcus.denker 9/19/2008 17:01'!
soundEnablingString
	^ self soundsEnabled
		ifFalse:
			['Turn sound on' translated]
		ifTrue:
			['Turn sound off' translated]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
soundQuickStart
	^ self
		valueOfFlag: #soundQuickStart
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
soundStopWhenDone
	^ self
		valueOfFlag: #soundStopWhenDone
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
soundTheme
	^ self
		valueOfFlag: #soundTheme
		ifAbsent: [SoundTheme]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 1/10/2010 08:01'!
soundThemeSetting
	^ PolymorphSystemSettings soundThemeClass! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 1/10/2010 08:01'!
soundThemeSetting: aClass
	PolymorphSystemSettings soundThemeClass: aClass! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
soundsEnabled
	^ self
		valueOfFlag: #soundsEnabled
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:28'!
soundsEnabledSetting
	^ SoundSettings soundEnabled! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:28'!
soundsEnabledSetting: aBoolean
	SoundSettings soundEnabled: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'mir 11/10/2003 14:28'!
standaloneSecurityChecksEnabled
 	^ self
 		valueOfFlag: #standaloneSecurityChecksEnabled
 		ifAbsent: [false]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:55'!
standardBalloonHelpFont
	^	StandardFonts balloonFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:34'!
standardButtonFont
	"Answer an attractive font to use for buttons"
	^ StandardFonts buttonFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:35'!
standardCodeFont
	"Answer the font to be used in code"
	
	^StandardFonts codeFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:35'!
standardDefaultTextFont
	^StandardFonts defaultFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:35'!
standardHaloLabelFont
	"Answer the font to be used in the eToys environment"
	^StandardFonts haloFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:35'!
standardListFont
	"Answer the font to be used in lists"
	^StandardFonts listFont! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:36'!
standardMenuFont
	"Answer the font to be used in menus"
	^StandardFonts menuFont! !

!Preferences class methodsFor: 'FreeType-addition' stamp: 'AlainPlantec 12/6/2009 19:36'!
standardSystemFont
	"Answer the standard system font "
	^StandardFonts defaultFont! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 21:28'!
startInUntrustedDirectory
	^ self startInUntrustedDirectorySetting
	! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:27'!
startInUntrustedDirectorySetting
	^ SecurityManager default startInUntrustedDirectory! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:28'!
startInUntrustedDirectorySetting: aBoolean
	SecurityManager default startInUntrustedDirectory: aBoolean! !

!Preferences class methodsFor: 'personalization' stamp: 'AlainPlantec 1/7/2010 23:43'!
storePreferencesIn: aFileName 
	| stream |
	#(#Prevailing #PersonalPreferences )  do:[:ea | self parameters  removeKey:ea  ifAbsent:[]].
	stream := ReferenceStream  fileNamed:aFileName.
	stream  nextPut:Parameters.
	stream  nextPut:self dictionaryOfPreferences.
	stream  nextPut:World fillStyle.
	stream close! !

!Preferences class methodsFor: 'personalization' stamp: 'nk 11/17/2002 12:08'!
storePreferencesToDisk
	Cursor wait showWhile: [
		[ self storePreferencesIn: 'my.prefs' ] on: Error do: [ :ex | self inform: 'there was an error storing your preferences to disk' ]]! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/18/2009 14:22'!
subPixelRenderColorFonts
	^  StrikeFont subPixelRenderColorFonts! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/18/2009 14:22'!
subPixelRenderFonts
	^ StrikeFont subPixelRenderFonts! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 09:59'!
swapControlAndAltKeys
	^ self swapControlAndAltKeysSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 09:59'!
swapControlAndAltKeysSetting
	^ InputEventSensor controlAltKeyDecodePolicy = #Swapped
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 10:02'!
swapControlAndAltKeysSetting: aBoolean
	aBoolean ifTrue: [InputEventSensor controlAltKeyDecodePolicy: #Swapped]
! !

!Preferences class methodsFor: 'standard queries' stamp: 'adrian-lienhard 5/22/2009 10:41'!
swapMouseButtons
	^ self
		valueOfFlag: #swapMouseButtons
		ifAbsent: [
			OSPlatform current platformFamily ~= #Windows ]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
syntaxHighlightingAsYouType
	^ self
		valueOfFlag: #syntaxHighlightingAsYouType
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
syntaxHighlightingAsYouTypeAnsiAssignment
	^ self
		valueOfFlag: #syntaxHighlightingAsYouTypeAnsiAssignment
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
syntaxHighlightingAsYouTypeLeftArrowAssignment
	^ self
		valueOfFlag: #syntaxHighlightingAsYouTypeLeftArrowAssignment
		ifAbsent: [false]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
systemWindowEmbedOK
	^ self
		valueOfFlag: #systemWindowEmbedOK
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 15:25'!
tabAmongFields
	^ self tabAmongFieldsSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/21/2009 12:15'!
tabAmongFieldsSetting
	^ UITheme currentSettings tabAmongFields! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/21/2009 12:15'!
tabAmongFieldsSetting: aBoolean
	UITheme currentSettings tabAmongFields: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
testRunnerWindowColor
	^ self
		valueOfFlag: #testRunnerWindowColor
		ifAbsent: [Color
				r: 0.65
				g: 0.753
				b: 0.976]! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:43'!
textHighlightColor
	^ self parameters at: #textHighlightColor! !

!Preferences class methodsFor: 'text highlighting' stamp: 'AlainPlantec 1/7/2010 23:43'!
textHighlightColor: aColor
	self parameters at: #textHighlightColor put: aColor! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 10:51'!
tinyDisplay
	^ self tinyDisplaySetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 10:50'!
tinyDisplaySetting
	^ DisplayScreen tiny! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/11/2009 10:51'!
tinyDisplaySetting: aBoolean
	DisplayScreen tiny: aBoolean
! !

!Preferences class methodsFor: 'get/set' stamp: 'hpt 9/26/2004 16:50'!
togglePreference: prefSymbol
	"Toggle the given preference. prefSymbol must be of a boolean preference"
	(self preferenceAt: prefSymbol ifAbsent: [self error: 'unknown preference: ', prefSymbol]) togglePreferenceValue! !

!Preferences class methodsFor: 'misc' stamp: 'AlainPlantec 12/7/2009 15:06'!
toggleSoundEnabling
     SoundSettings soundEnabled: SoundSettings soundEnabled not! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
transcriptWindowColor
	^ self
		valueOfFlag: #transcriptWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 0.8
				b: 0.4]! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
turnOffPowerManager
	^ self
		valueOfFlag: #turnOffPowerManager
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
uiTheme
	^ self
		valueOfFlag: #uiTheme
		ifAbsent: [UIThemeStandardSqueak]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 1/10/2010 07:42'!
uiThemeSetting
	^ PolymorphSystemSettings uiThemeClass ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 1/10/2010 07:42'!
uiThemeSetting: aClass
	PolymorphSystemSettings uiThemeClass: aClass! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/10/2009 15:39'!
unlimitedPaintArea
	^ self unlimitedPaintAreaSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/10/2009 15:39'!
unlimitedPaintAreaSetting
	^ false! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/10/2009 15:39'!
unlimitedPaintAreaSetting: aBoolean
	! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:52'!
updateFromServerAtStartup
	^ self updateFromServerAtStartupSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 22:51'!
updateFromServerAtStartupSetting
	^ AutoStart updateFromServerAtStartup! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 22:52'!
updateFromServerAtStartupSetting: aBoolean
	AutoStart updateFromServerAtStartup: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:55'!
updateSavesFile
	^ self updateSavesFileSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 22:55'!
updateSavesFileSetting
	^ Utilities updateSavesFile! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 22:55'!
updateSavesFileSetting: aBoolean
	Utilities updateSavesFile: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 23:00'!
upgradeIsMerge
	^ self upgradeIsMergeSetting
	! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 23:00'!
upgradeIsMergeSetting
	^ MCConfiguration upgradeIsMerge ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/17/2009 23:00'!
upgradeIsMergeSetting: aBoolean
	MCConfiguration upgradeIsMerge: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/19/2009 22:52'!
useFormsInPaintBox
	^ PaintBoxMorph useFormsInPaintBox! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 11:01'!
useLocale
	^ self useLocaleSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 11:00'!
useLocaleSetting
	^ Locale activated! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 11:01'!
useLocaleSetting: aBoolean
	Locale activated: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
useNewDiffToolsForMC
	^ self
		valueOfFlag: #useNewDiffToolsForMC
		ifAbsent: [true]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:03'!
useNewDiffToolsForMCSetting
	^ PSMCPatchMorph usedByDefault! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:04'!
useNewDiffToolsForMCSetting: aBoolean
	PSMCPatchMorph usedByDefault: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:38'!
useOnlyServicesInMenu
	^ self useOnlyServicesInMenuSetting
! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
useRBASTForPrettyPrint
	^ self
		valueOfFlag: #useRBASTForPrettyPrint
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 22:37'!
useServicesInBrowserButtonBar
	^ self useServicesInBrowserButtonBarSetting
! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
useSmartLabels
	^ self
		valueOfFlag: #useSmartLabels
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 15:07'!
useThemeSounds
	^ SoundSettings useThemeSounds! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:29'!
useThemeSoundsSetting
	^ SoundSettings useThemeSounds! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:29'!
useThemeSoundsSetting: aBoolean
	SoundSettings useThemeSounds: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 09:07'!
useUndo
	^ self useUndoSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:07'!
useUndoSetting
	^ CommandHistory useUndo! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 09:07'!
useUndoSetting: aBoolean
	CommandHistory useUndo: aBoolean! !

!Preferences class methodsFor: 'get/set' stamp: 'hpt 9/26/2004 16:49'!
valueOfFlag: aFlagName
	"Utility method for all the preferences that are boolean, and for backward compatibility"
	^self valueOfPreference: aFlagName ifAbsent: [false].! !

!Preferences class methodsFor: 'get/set' stamp: 'hpt 9/26/2004 16:48'!
valueOfFlag: aFlagName ifAbsent: booleanValuedBlock
	"the same as in #valueOfFlag:"
	^self valueOfPreference: aFlagName ifAbsent: booleanValuedBlock.! !

!Preferences class methodsFor: 'get/set' stamp: 'hpt 9/26/2004 16:49'!
valueOfPreference: aPreferenceSymbol
	"Answer the value of the given preference"
	^self valueOfPreference: aPreferenceSymbol ifAbsent: []! !

!Preferences class methodsFor: 'get/set' stamp: 'hpt 9/26/2004 16:49'!
valueOfPreference: aPreferenceSymbol ifAbsent: booleanValuedBlock
	"Answer the value of the given preference"
	^ (self preferenceAt: aPreferenceSymbol ifAbsent: [^ booleanValuedBlock value]) preferenceValue! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
versionsBrowserWindowColor
	^ self
		valueOfFlag: #versionsBrowserWindowColor
		ifAbsent: [Color
				r: 0.869
				g: 0.753
				b: 1.0]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/6/2009 22:14'!
visualExplorer
	^ ObjectExplorer showIcons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:12'!
visualExplorerSetting
	^ ObjectExplorer showIcons! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:12'!
visualExplorerSetting: aBoolean
	^ ObjectExplorer showIcons: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
visualizations
	^ self
		valueOfFlag: #visualizations
		ifAbsent: [true]! !

!Preferences class methodsFor: 'misc' stamp: 'MiguelCoba 7/25/2009 02:19'!
wantsChangeSetLogging
	"Answer whether method changes in the receiver should be logged to current change set.  This circumlocution avoids such logging for programmatically-compiled methods in Preferences, removing an annoyance"

	^ Author fullNamePerSe  ~= 'programmatic'! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/17/2009 21:29'!
warnAboutInsecureContent
	^ self warnAboutInsecureContentSetting
! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:28'!
warnAboutInsecureContentSetting
	^ SecurityManager default warnAboutInsecureContent! !

!Preferences class methodsFor: 'settings-semi-migration' stamp: 'AlainPlantec 12/17/2009 21:29'!
warnAboutInsecureContentSetting: aBoolean
	SecurityManager default warnAboutInsecureContent: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 14:41'!
warnIfNoChangesFile
	^ self warnIfNoChangesFileSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 14:41'!
warnIfNoChangesFileSetting
	^ SmalltalkImage checkChangesFileAvailability! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 14:41'!
warnIfNoChangesFileSetting: aBoolean
	SmalltalkImage checkChangesFileAvailability: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 14:37'!
warnIfNoSourcesFile
	^ self warnIfNoSourcesFileSetting! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 14:36'!
warnIfNoSourcesFileSetting
	^ SmalltalkImage checkSourcesFileAvailability! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 14:37'!
warnIfNoSourcesFileSetting: aBoolean
	SmalltalkImage checkSourcesFileAvailability: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
windowAnimation
	^ self
		valueOfFlag: #windowAnimation
		ifAbsent: [true]! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
windowAnimationDelay
	^ self
		valueOfFlag: #windowAnimationDelay
		ifAbsent: [10]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:43'!
windowAnimationDelaySetting
	^ UITheme currentAnimationSettings delay! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:43'!
windowAnimationDelaySetting: anInteger
	^ UITheme currentAnimationSettings delay: anInteger! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:28'!
windowAnimationSetting
	^ UITheme currentAnimationSettings useAnimation! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:33'!
windowAnimationSetting: aBoolean
	UITheme currentAnimationSettings useAnimation: aBoolean! !

!Preferences class methodsFor: 'standard queries' stamp: ''!
windowAnimationSteps
	^ self
		valueOfFlag: #windowAnimationSteps
		ifAbsent: [15]! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:45'!
windowAnimationStepsSetting
	^ UITheme currentAnimationSettings numberOfSteps ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/15/2009 10:45'!
windowAnimationStepsSetting: anInteger
	UITheme currentAnimationSettings numberOfSteps: anInteger! !

!Preferences class methodsFor: 'window colors' stamp: 'AlainPlantec 12/16/2009 18:42'!
windowColorFor: aModelClassName
	| classToCheck prefSymbol |
	self deprecated: 'Define a #preferredColor method in the class side of your model class instead'.
	self checkForWindowColors.
	classToCheck := Smalltalk at: aModelClassName.
	prefSymbol := self windowColorPreferenceForClassNamed: classToCheck name.
	[(classToCheck ~~ Object) and: [(self preferenceAt: prefSymbol) isNil]]
		whileTrue: 
				[classToCheck := classToCheck superclass.
				prefSymbol := self windowColorPreferenceForClassNamed: classToCheck name].
	^self valueOfPreference: prefSymbol ifAbsent: [Color white].! !

!Preferences class methodsFor: 'window colors' stamp: 'AlainPlantec 12/16/2009 21:28'!
windowColorPreferenceForClassNamed: aClassName
	self deprecated: 'Not used since Settings integration'! !

!Preferences class methodsFor: 'fonts' stamp: 'AlainPlantec 12/6/2009 19:38'!
windowTitleFont
	"Answer the standard font to use for window titles"
	^StandardFonts windowTitleFont! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
windowsActiveOnFirstClick
	^ self
		valueOfFlag: #windowsActiveOnFirstClick
		ifAbsent: [false]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/11/2009 13:40'!
wordStyleCursorMovement
	^ self wordStyleCursorMovementSetting
! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 13:39'!
wordStyleCursorMovementSetting
	^ ParagraphEditor walkAlongDisplayedLine.! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/11/2009 13:40'!
wordStyleCursorMovementSetting: aBoolean
	ParagraphEditor walkAlongDisplayedLine: aBoolean! !

!Preferences class methodsFor: 'settings-no-migration' stamp: ''!
workspaceWindowColor
	^ self
		valueOfFlag: #workspaceWindowColor
		ifAbsent: [Color
				r: 1.0
				g: 1.0
				b: 0.8]! !

!Preferences class methodsFor: 'standard queries' stamp: 'AlainPlantec 12/7/2009 09:13'!
worldTaskbarWindowPreview
	^ TaskbarMorph showWindowPreview ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:16'!
worldTaskbarWindowPreviewSetting
	^ TaskbarMorph showWindowPreview ! !

!Preferences class methodsFor: 'settings-migration' stamp: 'AlainPlantec 12/8/2009 11:16'!
worldTaskbarWindowPreviewSetting: aBoolean
	TaskbarMorph showWindowPreview: aBoolean! !

!Preferences methodsFor: 'look in class' stamp: 'di 12/4/1999 15:11'!
seeClassSide
	"All the code for Preferences is on the class side"! !

Object subclass: #PreferencesUnloader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Core'!

!PreferencesUnloader classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/8/2010 09:50'!
unloadPreferenceStuffs
	"self unloadPreferenceStuffs"
	PreferenceBrowser unregisterFromOpenMenu.
	(MCPackage named: 'DeprecatedPreferences') unload.
	SmalltalkImage current fixObsoleteReferences.	
	! !

Object subclass: #TaskListMorphPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!TaskListMorphPreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:31'!
initialize
	"Initialize the receiver."
	Preferences
		addPreference: #keepTasklistOpen
		categories: #(#windows )
		default: false
		balloonHelp: 'Whether the tasklist is closed (and the selected window activated) when the command key is released'! !

Object subclass: #UIThemePreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DeprecatedPreferences-Users'!

!UIThemePreferences classSide methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/5/2010 12:33'!
initialize
	"Set up ui enhancement preferences here."
	Preferences
		addPreference: #showTextEditingState
		categories: #(#morphic )
		default: false
		balloonHelp: 'When enabled the editing state of PluggableTextMorphs is shown as a colored inset border.' translated;
		
		addPreference: #externalFocusForPluggableText
		categories: #(#morphic )
		default: true
		balloonHelp: 'When enabled the focus indication for PluggableTextMorphs will be drawn in the border rather than around the embedded TextMorph.' translated;
		
		addPreference: #mouseClickForKeyboardFocus
		categories: #(#morphic )
		default: false
		balloonHelp: 'When enabled the mouse button must be clicked within a morph for it to take the keyboard focus.' translated;
		
		addPreference: #gradientScrollbarLook
		categories: #(#scrolling #windows )
		default: true
		balloonHelp: 'Scrollbars have a nicer appearance using UITheme.' translated;
		
		addPreference: #gradientButtonLook
		categories: #(#buttons #windows )
		default: true
		balloonHelp: 'Buttons have a nicer appearance using UITheme.' translated;
		
		addPreference: #windowsActiveOnFirstClick
		categories: #(#windows )
		default: false
		balloonHelp: 'When disabled, the first click of an inactive window will only activate it rather than also controlling a submorph.' translated;
		
		addPreference: #fadedBackgroundWindows
		categories: #(#windows )
		default: true
		balloonHelp: 'Background windows appear more "washed out" to distinguish from the active window.' translated;
		
		addPreference: #windowAnimation
		categories: #(#windows )
		default: true
		balloonHelp: 'Animate the minimising, restoring, expanding and (optionally) closing of windows.' translated;
		
		addPreference: #noWindowAnimationForClosing
		categories: #(#windows )
		default: false
		balloonHelp: 'Don''t animate the closing of windows.' translated;
		
		addNumericPreference: #windowAnimationDelay
		categories: #(#windows )
		default: 10
		balloonHelp: 'The delay between each step of the window animation in milliseconds.' translated;
		
		addNumericPreference: #windowAnimationSteps
		categories: #(#windows )
		default: 15
		balloonHelp: 'The number of steps in the window animation.' translated.! !
BooleanPreferenceView initialize!
CuvierMorphPreferences initialize!
DeprecationPreferences initialize!
HaloThemePreferenceView initialize!
LocalePreferences initialize!
MCConfigurationPreferences initialize!
MorphicPreferences initialize!
NetworkPreferences initialize!
PBBooleanPreferenceView initialize!
PBColorPreferenceView initialize!
PBHaloThemePreferenceView initialize!
PBNumericPreferenceView initialize!
PBSoundThemePreferenceView initialize!
PBTextPreferenceView initialize!
PBUIThemePreferenceView initialize!
PBWindowColorPreferenceView initialize!
PreferenceBrowser initialize!
TaskListMorphPreferences initialize!
UIThemePreferences initialize!
